//SLAMM SOURCE CODE copyright (c) 2009 - 2012 Warren Pinnacle Consulting, Inc.
//Code Use and Redistribution is Subject to Licensing, SEE SLAMM_License.txt
//

unit DrawGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Math,
  StdCtrls, ExtCtrls, jpeg, ComCtrls, System.Types, GLOBAL, UTILITY, ImgList, ToolWin, Profile,
  Progress, ClipBrd, ShellAPI, SLR6, GLDraw, Gauges, Buttons;

CONST
  PixelCountMax = 32768;

TYPE
  pRGBTripleArray = ^TRGBTripleArray;
  TRGBTripleArray = ARRAY[0..PixelCountMax-1] OF TRGBTriple;


type
  TGridForm = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Memo1: TMemo;
    RunPanel: TPanel;
    ProgressLabel: TLabel;
    Gauge1: TGauge;
    Button1: TButton;
    YearLabel: TLabel;
    SLRLabel: TLabel;
    ProtectionLabel: TLabel;
    xlabel2: TLabel;
    ylabel2: TLabel;
    DepthLabel: TLabel;
    CategoryLabel: TLabel;
    PageControl1: TPageControl;
    SubsiteEditSheet: TTabSheet;
    AttribPanel: TPanel;
    EstNameCapt: TLabel;
    BoundaryWarning: TLabel;
    PointWarning: TLabel;
    Label1: TLabel;
    ShowLines: TRadioButton;
    ShowCells: TRadioButton;
    EditBox: TComboBox;
    DeleteEst: TButton;
    AddEst: TButton;
    DefineBound: TButton;
    DefineVector: TButton;
    NameEdit: TEdit;
    Panel2: TPanel;
    ShowAll: TRadioButton;
    Panel3: TPanel;
    Panel1: TPanel;
    Panel4: TPanel;
    Label3: TLabel;
    DefEst: TRadioButton;
    DefInput: TRadioButton;
    DefOutput: TRadioButton;
    Zoombox2: TComboBox;
    SubsiteParmButt: TButton;
    FWFlowButton: TButton;
    helpFileAttrib: TBitBtn;
    FWExtentOnly: TCheckBox;
    CopyClip1: TButton;
    SaveSim1: TButton;
    AnalysisSheet: TTabSheet;
    Panel11: TPanel;
    MapTitle: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    DotSizeLabel: TLabel;
    SalAnalysis2: TButton;
    DotSizeBox: TComboBox;
    HelpButton: TBitBtn;
    ShowDikes: TCheckBox;
    GraphBox: TComboBox;
    ROSPanel: TPanel;
    ROSLabel: TLabel;
    ROSButton: TButton;
    ElevationButton: TButton;
    NextStepButton: TButton;
    StopPausingButton: TButton;
    ZoomBox: TComboBox;
    HaltButton: TButton;
    ViewLegButt: TButton;
    ToolPanel: TPanel;
    StatLabel: TLabel;
    ToolBox1: TComboBox;
    PanCheckBox: TCheckBox;
    CopyClip2: TButton;
    SaveSim2: TButton;
    TabSheet1: TTabSheet;
    Panel12: TPanel;
    PenWidthLabel: TLabel;
    MapTitle2: TLabel;
    Label5: TLabel;
    AddDikeButt: TButton;
    FillDikeButt: TButton;
    PenWidthBox: TComboBox;
    ShowDikes2: TCheckBox;
    CategoryBox: TComboBox;
    FillDikesBox: TCheckBox;
    FillNoDikesBox: TCheckBox;
    CheckBox2: TCheckBox;
    PolyCells: TButton;
    SaveSim3: TButton;
    FillDryLandButton: TButton;
    DoneDrawingButton: TButton;
    ZoomBox3: TComboBox;
    BitBtn3: TBitBtn;
    Panel5: TPanel;
    CopyClip3: TButton;
    Panel6: TPanel;
    WPCUtilitiesSheet: TTabSheet;
    Panel7: TPanel;
    SaveSubsitesButton: TButton;
    Button4: TButton;
    SAVButton: TButton;
    procedure ViewLegButtClick(Sender: TObject);
    procedure HaltButtonClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HideMapButtonClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CopyMapToClipboard(Sender: TObject);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ShowDikesClick(Sender: TObject);
    procedure ZoomBoxChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AddEstClick(Sender: TObject);
    procedure DeleteEstClick(Sender: TObject);
    procedure DefineBoundClick(Sender: TObject);
    procedure DefineVectorClick(Sender: TObject);
    procedure EditBoxChange(Sender: TObject);
    procedure NameEditChange(Sender: TObject);
    procedure NameEditExit(Sender: TObject);
    procedure ShowCellsClick(Sender: TObject);
    procedure ShowLinesClick(Sender: TObject);
    procedure AddDikeButtClick(Sender: TObject);
    procedure FillDikeButtClick(Sender: TObject);
    procedure DefEstClick(Sender: TObject);
    procedure SubsiteParmButtClick(Sender: TObject);
    procedure ROSButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FillDikesBoxClick(Sender: TObject);
    procedure TabChangeClick(Sender: TObject);
    procedure ElevationButtonClick(Sender: TObject);
    procedure FWFlowButtonClick(Sender: TObject);
    procedure GraphBoxChange(Sender: TObject);
    procedure NextStepButtonClick(Sender: TObject);
    procedure FillNoDikesBoxClick(Sender: TObject);
    procedure helpFileAttribClick(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure FWExtentOnlyClick(Sender: TObject);
    procedure PolyCellsClick(Sender: TObject);
    procedure DoneDrawingButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MapSaveSimulationButtonClick(Sender: TObject);
    procedure FillDryLandButtonClick(Sender: TObject);
    procedure SAVButtonClick(Sender: TObject);
    procedure SalAnalysis2Click(Sender: TObject);
    procedure SaveSubsitesButtonClick(Sender: TObject);
    procedure StopPausingButtonClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PanCheckBoxClick(Sender: TObject);
    procedure ScrollBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    LastRow,EditIndex,aX,aY,zX,zY,wd,ht : integer;
    Row: pRGBTripleArray;
    Bitstream: TMemoryStream;
    Updating, FillDikes, FillNoDikes: Boolean;
    SRow, SCol, ERow, ECol: Integer;
    FLastDown: TPoint;
    Procedure Graph3D;
  public
    DontDraw: Boolean;
    SaveBtStream: Boolean;
    SS: TSLAMM_Simulation;
    SlpFileN: String;
    DrawingRect : Boolean;
    DefiningBoundary, DefiningVector: Boolean;
    PolyingCells, DrawingCells, FillingCells, FillCategory: Boolean;
    DikesChanged, NWIChanged: Boolean;
    IsVisible: Boolean;
    Rows, Cols, MapNR,MapNC: Integer;
    ZoomFactor: Double;
    FILLCAT : Category;
    GridScale: Double;
    ThisSite: TSite;
    NextOriginX, NextOriginY: Integer;
    ROSShowing: Integer;
    DisposeWhenClosed: Boolean;
    DrawingTopLayer: Boolean;
    PolyPoints: TPointArray;
    DotSizeBoxIndex, NumPolyPts: Integer;
    Procedure DrawBound(Var TPoly: TPolygon);
    Procedure ShowDikesOrConnect(ShowConnect:Boolean);
    Function ZF_From_Screen: Double;
    procedure ShowRunPanel;
    Function CategoryFromComboBox: Category;
    Procedure UpdateEditBox;
    Procedure ShowEditItems;
    Procedure DrawCell(Cl: PCompressedCell; ER,EC: Integer; Cat: Category; Diked,IsROS,Optim: Boolean; GBII: Integer);
    Procedure EditAttributes(NR,NC: Integer; TSS: TSLAMM_Simulation);
    Procedure DrawArrow(P1,P2: TPoint);
    Procedure DrawVector;
    Procedure DrawBoundary(IsEst: Boolean);
{    Procedure DrawSubsites; }
    Procedure DrawOutputsites;
    Procedure HighlightCells;
    Function DrawEntireMap(OutSite: Integer; ShowProg, ROS: Boolean): Boolean;
    Function ShowMap(NR,NC: Integer; Var Site: TSite; TSS: TSLAMM_Simulation): Boolean;
    Function ZF(i: Integer): Integer;
    Function GetMinElev(Cl: PCompressedCell; ER,EC: Integer): Double;
    Procedure SaveBitstream;
    Procedure LoadBitstream;
    Procedure SaveMapToGIF(FileN: String);
    { Public declarations }
  end;

var
  GridForm: TGridForm;


implementation

uses SLAMMLegend, Legend2, SiteEdits, Elev_Analysis, FWFlowEdits, System.Generics.Collections, System.UITypes, Uncert, GIFImg, main, FFForm, Stack, TeCanvas ;

{$R *.DFM}

procedure TGridForm.SalAnalysis2Click(Sender: TObject);
begin
  //ElevAnalysisForm.MapLoaded := True;
  //ElevAnalysisForm.ElevationAnalysis(SS);

  SalinityForm.MapLoaded := True;
  SalinityForm.SS := SS;
  Salinityform.ShowSalinityAnalysis;
  ProgForm.Cleanup;
  Salinityform.Showmodal;
end;

procedure TGridForm.SAVButtonClick(Sender: TObject);
begin
  SS.CalculateEucDistances;
  SS.CalculateProbSAV;
end;

Procedure TGridForm.SaveBitStream;
begin
  if Not SaveBtStream then Exit;
  if Bitstream <> nil then
     Bitstream.free;
  BitStream := TMemoryStream.Create;
  Image1.Picture.Bitmap.SaveToStream(BitStream);
end;

Procedure TGridForm.LoadBitStream;
Begin
  if Not SaveBtStream then Exit;
  If (Bitstream=nil) then Exit;
  BitStream.Position := 0;
  Image1.Picture.Bitmap.LoadFromStream(BitStream);
End;

{----------------------------------------------------------------------------------------------------}

Function TGridForm.GetMinElev(Cl: PCompressedCell; ER,EC: Integer): Double;
Var MnElev: Double;
    i: Integer;
    MinCat: Category;
Begin
  MnElev := 9999999;
  MinCat := Blank;
  For i := 1 to NUM_CAT_COMPRESS do
    If (CL.MinElevs[i]<MnElev) and (Cl.Widths[i] > 0) then
      Begin
        MnElev := CL.Minelevs[i];
        MinCat := CL.Cats[i];
      End;
  GetMinElev := MnElev;

  If USE_DATAELEV and (SS.OptimizeLevel > 1) then
   if MinCat in [DevDryLand, UndDryLand] then
     if MnElev = ELEV_CUTOFF then
         GetMinElev := SS.DataElev[(SS.Site.Cols*ER)+EC] / 1000;

End;

{----------------------------------------------------------------------------------------------------}

Function TGridForm.ZF(i: Integer): Integer;
Begin
  ZF := Trunc(i*ZoomFactor);
End;

Function ElevCol(Height: Double): TColor;
Begin
    if Height < -2 then                          result:= $00660000 else
    if (Height >= -2) and (Height < -1.5) then   result:= $00666600 else
    if (Height >= -1.5) and (Height < -1.0) then result:= $00667700 else
    if (Height >= -1) and (Height < -0.5) then   result:= $00668800 else
    if (Height >= -0.5) and (Height < 0) then    result:= $00669900 else
    if (Height >= 0) and (Height < 0.5) then     result:= $0066AA00 else
    if (Height >= 0.5) and (Height < 1) then     result:= $0066BB00 else
    if (Height >= 1) and (Height < 1.5) then     result:= $0066CC00 else
    if (Height >= 1.5) and (Height < 2) then     result:= $0066DD00 else
    if (Height >= 2) and (Height < 2.5) then     result:= $0066EE00 else
    if (Height >= 2.5) and (Height < 3) then     result:= $0066FF00 else
     if (Height >= 3) and (Height < 3.5) then    result:= $0066FF11 else
    if (Height >= 3.5) and (Height < 4) then     result:= $0066FF22 else
    if (Height >= 4) and (Height < 4.5) then     result:= $0066FF33 else
    if (Height >= 4.5) and (Height < 5) then     result:= $0066FF44 else
    if (Height >= 5) and (Height < 5.5) then     result:= $0066FF55 else
    if (Height >= 5.5) and (Height < 6) then     result:= $0066FF66 else
    if (Height >= 6) and (Height < 6.5) then     result:= $0066FF77 else
    if (Height >= 6.5) and (Height < 7) then     result:= $0066FF88
    else {if Height > 7  then }                  result:= $0066FF99;

    If height = 999 then result := clWhite;
End;

{----------------------------------------------------------------------------------------------------}

Procedure TGridForm.DrawCell(Cl: PCompressedCell; ER,EC: Integer; Cat: Category; Diked,IsROS,Optim: Boolean; GBII: Integer);
Var ColorNeutral: Boolean;
Const TRGBWhite: TRGBTriple = (rgbtBlue:255;rgbtGreen:255;rgbtRed:255;);

    Function NeutralColors(watercol: TColor): TColor;
    Begin
      Case Cat of
         UndDryLand: Result := $00006400;
         DevDryLand: Result := $00004200;
         InlandOpenWater..OpenOcean:  Result := watercol;
         Blank: Result := CLWhite;
         else Result := $00006400;
       end; {Case}
    End;

    Function SalColor(lev: integer): Tcolor;
    var
      sal: double;
    begin
      LegendForm.GMin := 0;
      LegendForm.GMax := 30;
      Sal := Cl.Sal[lev];
      If Sal<0 then Result := NeutralColors(clblack)
              // else If Sal=30 then Result := SS.GridColors[OpenOcean]
               else Result := ColorGradient(0,30,Sal);
    end;

    Function SubsidenceColor(ER,EC: integer): Tcolor;
    var
      Subsd: double;
      TSub : TSubSite;

    begin
      LegendForm.GMin := -5;
      LegendForm.GMax := 15;

      TSub := ThisSite.GetSubSite(EC,ER,Cl);
      If (SS.UpliftFileN='') then Subsd := TSub.Historic_Trend - 1.7 {estimate based on eustatic trend and historic gage}
                             else Subsd := -(Cl.Uplift * 10);  {cm/year  *  mm/yr}

      If Subsd<-5 then Subsd := -5 ;
      If Subsd>15 then Subsd := 15 ;

      Result := ColorGradient(-5,15,Subsd);
    end;

    Function MTLNAVDColor(ER,EC: integer): Tcolor;
    begin
      LegendForm.GMin := SS.MinMTL;
      LegendForm.GMax := SS.MaxMTL;
      Result := ColorGradient(SS.MinMTL,SS.MaxMTL,Cl.MTLminusNAVD);
    end;

    Function SAVColor: Tcolor;
    begin
      LegendForm.GMin := 0;
      LegendForm.GMax := 1;

      If CL.ProbSAV<Tiny then Result := NeutralColors(clBlack)
                         else Result := ColorGradient(0,1,Cl.ProbSAV);
    end;


    Function AccrColor(ER,EC: integer): Tcolor;
    var
      TurbFactor, accr: double;
      nfw, fw: Integer;
      TSub : TSubSite;

    Const ACCRMIN = 0; ACCRMAX = 10.0;

    begin
      LegendForm.GMin := ACCRMIN;
      LegendForm.GMax := ACCRMAX;

      TSub := ThisSite.GetSubSite(EC,ER,Cl);

      accr := 0;

      Case Cat of
          Scrubshrub,IrregFloodMarsh:         accr := SS.IrregFloodAccrete(CL,TSub);
          RegFloodMarsh:                      accr := SS.RegFloodAccrete(CL,TSub);
          TidalFlat,OceanFlat, VegTidalFlat:  accr := SS.TidalFlat_Sed(CL,TSub);
          OceanBeach,EstuarineBeach:          accr := TSub.Fixed_TF_Beach_Sed;
          InlandFreshMarsh:                   accr := TSub.InlandFreshAccr;
          TidalFreshMarsh:                    accr := SS.TidalFreshAccrete(CL,TSub);
          TidalSwamp:                         accr := TSub.TSwampAccr;
          Swamp, CypressSwamp:                accr := TSub.SwampAccr;
          Mangrove :                          accr := TSub.MangroveAccr;
       End; {Case}


      {Add Turbidity Factor}
      TurbFactor := 1.0;
      nfw := 0;
      With SS do
      If Accr> 0 then
        For fw := 0 to NumFWFlows -1 do
         If FWInfluenced(ER,EC,fw) then
           If FWFlows[fw].UseTurbidities then
             Begin
               inc(nfw);
               If nfw=1 then TurbFactor :=  FWFlows[fw].TurbidityByYear(Year)
                        else TurbFactor := (FWFlows[fw].TurbidityByYear(Year) + (TurbFactor * (nfw-1))) / nfw   // calcuate average turbfactor
             End;

      If Accr=0 then Result := NeutralColors(clNavy)
                else Result := ColorGradient(ACCRMIN,ACCRMAX,accr* TurbFactor);
    end;

    Function ElevColor(ER,EC: integer): Tcolor;
    var
      elev: double;
     // depth: double;
    begin

      elev:= Getminelev(Cl, ER, EC);

(*    depth := -elev;
      IF depth > 30 then Depth := 30;
      If Depth < -2 then Result := NeutralColors
                    else Result := ColorGradient(-2,30,28-depth);
      Exit;  {Gradient Depth Code} *)

      Result := ElevCol(Elev);

    end;

    Function ErosionColor(BTF: Boolean; ER,EC: integer): Tcolor;
    Var EL: Single;
    begin
      ColorNeutral := False;
      LegendForm.GMin := 0;
      LegendForm.GMax := GridScale;
      If BTF then EL := Cl.BTFErosionLoss
             else EL := Cl.ErosionLoss;

      If EL>0 then Result := ColorGradient(0,GridScale,EL)
              else Begin
                     Result := NeutralColors(clnavy);
                     ColorNeutral  := True;
                    End;
    end;

    Function TRGBColor(TCd: TColor): TRGBTriple;
    Begin
      Result.rgbtRed := Byte(TCd);
      Result.rgbtGreen := Byte(TCd shr 8);
      Result.rgbtBlue := Byte(TCd shr 16);
    End;

    Procedure DrawPixel(Xd,Yd: Integer; RGBT: TRGBTriple);
    Var TRGB: TRGBTriple;
    Begin
      if Yd<>LastRow then
        Begin
          Row := Image1.Picture.Bitmap.Scanline[Yd];
          LastRow := Yd;
        End;
      Row[Xd] := RGBT;
    End;

Var X,Y: Integer;
    TC: TRGBTriple;

    Procedure DrawBigDots;
    Begin
     DrawPixel(X,Y,TC); //Size 1, 1 dot
     If (X+1 <= Image1.Width)
      and (Y+1 <= Image1.Height) then
       Begin
        DrawPixel(X+1,Y,TC);
        DrawPixel(X,Y+1,TC);
        DrawPixel(X+1,Y+1,TC);  //Size 2, 4 dots

        If (DotSizeBoxIndex>1)  // size 3, 9 dots
         and (X-1 > 0 )
          and (Y-1 > 0) then
           Begin
            DrawPixel(X-1,Y,TC);
            DrawPixel(X,Y-1,TC);
            DrawPixel(X-1,Y-1,TC);
            DrawPixel(X-1,Y+1,TC);
            DrawPixel(X+1,Y-1,TC);

            If (DotSizeBoxIndex>2)  // size 4, 16 dots
            and(X+2 <= Image1.Width)
             and (Y+2 <= Image1.Height) then
              Begin
               DrawPixel(X+2,Y-1,TC);
               DrawPixel(X+2,Y,TC);
               DrawPixel(X+2,Y+1,TC);
               DrawPixel(X+2,Y+2,TC);

               DrawPixel(X-1,Y+2,TC);
               DrawPixel(X,Y+2,TC);
               DrawPixel(X+1,Y+2,TC);

               If (DotSizeBoxIndex>3) //Size 5, 25 dots
                and (X-2 > 0)
                 and (Y-2 > 0) then
                  Begin
                    DrawPixel(X-2,Y-2,TC);

                    DrawPixel(X-2,Y-1,TC);
                    DrawPixel(X-2,Y  ,TC);
                    DrawPixel(X-2,Y+1,TC);
                    DrawPixel(X-2,Y+2,TC);

                    DrawPixel(X-1,Y-2,TC);
                    DrawPixel(X,  Y-2,TC);
                    DrawPixel(X+1,Y-2,TC);
                    DrawPixel(X+2,Y-2,TC);
                  End;  //itemindex > 3
              End;  //itemindex > 2
           End;  //itemindex > 1
       End;
    End;  //drawbigdots

Begin    {Drawcell}

  If Optim then if ((Cat=blank) and not IsROS) then exit;  //optimization for drawing blank cells
  If (ZoomFactor = 0.5) then
    Begin
      If (ER Mod 2 > 0) then exit;
      If (EC Mod 2 > 0) then exit;
    End;
  If (ZoomFactor = 0.25) then
    Begin
      If (ER Mod 4 > 0) then exit;
      If (EC Mod 4 > 0) then exit;
    End;
  If (ZoomFactor = 0.125) then
    Begin
      If (ER Mod 8 > 0) then exit;
      If (EC Mod 8 > 0) then exit;
    End;

  X :=1+TRUNC(EC*ZoomFactor);
  Y :=1+TRUNC(ER*ZoomFactor);
  ColorNeutral := True;

  TC := TRGBWhite;
  If IsROS then TC := TRGBWhite {ROS color for now}
     else If Diked then TC := TRGBColor(ClYellow) {dike color for now}
     else Case GBII of
            1: TC := TRGBColor(ElevColor(ER,EC));
            2: TC := TRGBColor(SalColor(1));
            3: TC := TRGBColor(SalColor(2));
            4: TC := TRGBColor(SalColor(3));
            5: TC := TRGBColor(SalColor(4));
            6: TC := TRGBColor(AccrColor(ER,EC));
            7: TC := TRGBColor(SubsidenceColor(ER,EC));
            8: TC := TRGBColor(MTLNAVDColor(ER,EC));
            9: TC := TRGBColor(ErosionColor(False,ER,EC));
            10: TC := TRGBColor(ErosionColor(True,ER,EC));
            11: TC := TRGBColor(AlternativeGridColors[Cat]);
            //12: TC := TRGBColor(SAVColor);
            else TC := SS.GridColors2[Cat];
           End; {Case}

  If (Not DrawingTopLayer) or (Diked) then DrawPixel(X,Y,TC);

  If ((GBII = 9) or (GBII = 10)) {erosion color}
   and (not colorneutral) and drawingtoplayer and (DotSizeBoxIndex > 0) then
     DrawBigDots;

  If ZoomFactor > 1 then {200%}
    Begin
      DrawPixel(X+1,Y,TC);
      DrawPixel(X,Y+1,TC);
      DrawPixel(X+1,Y+1,TC);
    End;
   If ZoomFactor > 2 then {300%}
    Begin
      DrawPixel(X+2,Y,TC);
      DrawPixel(X,Y+2,TC);
      DrawPixel(X+2,Y+2,TC);
      DrawPixel(X+2,Y+1,TC);
      DrawPixel(X+1,Y+2,TC);
    End;
  if ZoomFactor > 3 then {400%}
    begin
      DrawPixel(X+3,Y,TC);
      DrawPixel(X,Y+3,TC);
      DrawPixel(X+3,Y+3,TC);
      DrawPixel(X+3,Y+1,TC);
      DrawPixel(X+3,Y+2,TC);
      DrawPixel(X+1,Y+3,TC);
      DrawPixel(X+2,Y+3,TC);
    end;
End;

{----------------------------------------------------------------------------------------------------}

Function TGridForm.DrawEntireMap(OutSite: Integer; ShowProg, ROS: Boolean): Boolean;  {from scratch}
Var GBII, DrawRow,DrawCol, ER,EC: Integer;
    PCL: CompressedCell;
    DD, DoubleDraw: Boolean;
    Catg : Category;
Begin
  Result := True;
  GraphBox.Enabled := False;
  ZoomBox.Enabled := False;
  ZoomBox2.Enabled := False;
  ZoomBox3.Enabled := False;

  If ShowProg then Begin
                     ProgForm.YearLabel.Visible       := False;
                     ProgForm.SLRLabel.Visible        := False;
                     ProgForm.ProtectionLabel.Visible := False;
                     ProgForm.ProgressLabel.Caption   := 'Drawing Map';
                     If Visible then ShowRunPanel;
                   End;

  If OutSite>0 then ZoomFactor :=  1.0; {no zoom for output sites}
  If ROS then
    Begin
      ZoomFactor := SS.ROS_Resize;  {Set to 2-4 if zooming desired when displaying "Raster Output Sites"}
    End;

  TRY

  Rows := TRUNC(MapNR * ZoomFactor);  Cols := TRUNC(MapNC * ZoomFactor);

  Scrollbox1.VertScrollBar.Range:=Trunc(MapNR*ZoomFactor)+2;
  Scrollbox1.HorzScrollBar.Range:=Trunc(MapNC*ZoomFactor)+2;

  Image1.Picture.Bitmap.Free;
  Image1.Picture.Bitmap := TBitmap.Create;
  Image1.Picture.Bitmap.PixelFormat := pf24bit;  // Do this first

  Image1.Height:=TRUNC(MapNR*ZoomFactor)+2;
  Image1.Width:=TRUNC(MapNC*ZoomFactor)+2;
  Image1.Picture.Bitmap.Height:=TRUNC(MapNR*ZoomFactor)+2;
  Image1.Picture.Bitmap.Width:=TRUNC(MapNC*ZoomFactor)+2;

  Image1.Canvas.Pen.Style := PSSolid;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.Brush.Color := ClWhite;
  Image1.Canvas.Pen.Color := ClWhite;
  Image1.Canvas.Rectangle(0, 0, TRUNC(MapNC*ZoomFactor)+2, TRUNC(MapNR*ZoomFactor)+2);

  With SS do
   If OutSite=0 then
     Begin
       SRow := 0;
       ERow := MapNR-1;
       SCol := 0;
       ECol := MapNC-1;
     End
    else If ROS then with Site.ROSBounds[OutSite-1] do
      Begin
         SRow := TRUNC(Y1);
         ERow := TRUNC(Y2);
         SCol := TRUNC(X1);
         ECol := TRUNC(X2);
      End
    else with Site.OutputSites[OutSite-1] do
      Begin
        If UsePolygon
          then with Poly do
            Begin
              SRow := MinRow;
              ERow := MaxRow;
              SCol := MinCol;
              ECol := MaxCol;
            End
          else with Rec do
            Begin
              SRow := Min(Y1,Y2)-1;
              ERow := Max(Y1,Y2)-1;
              SCol := Min(X1,X2)-1;
              ECol := Max(X1,X2)-1;
            End;
      End;

  GBII := GraphBox.ItemIndex;
  DotSizeBoxIndex := DotSizeBox.ItemIndex;
  DoubleDraw := ((GBII=9) or (GBII=10)) and (DotSizeBoxIndex > 0);  {erosion maps require double draw}

  Image1.Visible := False;
  For DD := False to DoubleDraw do
   For ER:=SRow to ERow do
    Begin
     For EC:=SCol to ECol do
      Begin
        DrawingTopLayer := DD;
        If (ZoomFactor = 0.5) then
          Begin
            If (ER Mod 2 > 0) then Continue;
            If (EC Mod 2 > 0) then Continue;
          End;
        If (ZoomFactor = 0.25) then
          Begin
            If (ER Mod 4 > 0) then Continue;
            If (EC Mod 4 > 0) then Continue;
          End;
        If (ZoomFactor = 0.125) then
          Begin
            If (ER Mod 8 > 0) then Continue;
            If (EC Mod 8 > 0) then Continue;
          End;

        SS.RetA(ER,EC,PCl);
        DrawRow := ER-SRow;
        DrawCol := EC-SCol;
        CatG := Category(GetCellCat(@PCl));

        If (Not ROS) and (OutSite<1) then DrawCell(@PCL,DrawRow,DrawCol,CatG,False,False,true,GBII)
        else
          With SS do
           If ROS and (ROSArray <> nil)
             then
               If (ROSArray[(Site.Cols*ER)+EC] <> OutSite)
                 then DrawCell(@PCL,DrawRow,DrawCol,Blank,False,False,true,GBII)
                 else DrawCell(@PCL,DrawRow,DrawCol,CatG,False,False,true,GBII)
             else with SS.Site.OutputSites[OutSite-1] do
               If UsePolygon then
                Begin
                         If Poly.InPoly(ER,EC) then DrawCell(@PCL,DrawRow,DrawCol,CatG,False,False,true,GBII)
                                               else DrawCell(@PCL,DrawRow,DrawCol,Blank,False,False,true,GBII);
                        End
                  else DrawCell(@PCL,DrawRow,DrawCol,CatG,False,False,true,GBII);
      End;  {EC Loop}

    If SS.UserStop then Break;
    If ShowProg then Result := ProgForm.Update2Gages(Trunc((ER-SRow+1)/(ERow-SRow+1)*(100)));
    If Not Result then Break;
    Application.Processmessages;
   End;

  Finally

  Image1.Invalidate;
  LastRow := -9999;
  Image1.Visible := True;
  GraphBox.Enabled := True;
  ZoomBox.Enabled := True;
  ZoomBox2.Enabled := True;
  ZoomBox3.Enabled := True;

    ProgForm.Hide;
    RunPanel.Visible := False;
    if (outsite = 0) and (not ROS) then
      SaveBitstream;

  End;
End;

{----------------------------------------------------------------------------------------------------}

Function TGridForm.ShowMap(NR,NC: Integer; Var Site: TSite; TSS: TSLAMM_Simulation): Boolean;
Var MR: TModalResult;
Begin
  SS := TSS;
  DrawingRect := False;

  ToolBox1.ItemIndex := 1;

  MapNR := NR;
  MapNC := NC;

       SRow := 0;
       ERow := MapNR-1;
       SCol := 0;
       ECol := MapNC-1;

  GridScale := Site.Scale;
  ThisSite := Site;
  SS.UserStop:=False;

  ROSPanel.Visible := Site.MaxROS > 0;
  ROSShowing := 0;

  ProgForm.Show;
  SaveBtStream := False;
  Result := DrawEntireMap(0,True,False);
  If Not Result then Exit;

  If not SS.QA_Tools then Show;
  SS.UserStop:=False;

  If SS.QA_Tools then
    Begin
      MapTitle.Visible := True;
      MapTitle.Caption:= 'Unprocessed Elevations (NWI Map Date)';
      RunPanel.Visible := False;
      hide;
      MR := ShowModal;
      IF (MR=2) then if MessageDlg('Stop Simulation Execution And Return to Main Menu? ',mtconfirmation,[mbyes,mbno],0) = mryes then
                MR := MRAbort;   // Disambiguation of X key

      If MR = MRAbort then Begin SS.UserStop:=True; exit; End;
      If MR = MRIgnore then SS.QA_Tools := False;
      MapTitle.Visible := False; Show; IsVisible := True;
    end;
End;

{----------------------------------------------------------------------------------------------------}


procedure TGridForm.ShowRunPanel;
begin
  RunPanel.Top := 0;
  RunPanel.Visible := True;
  RunPanel.BringToFront;

  ProgForm.PL2 := Pointer(ProgressLabel);
  ProgForm.G2 := Pointer(Gauge1);
  ProgForm.f2 := Pointer(Self);
  ProgForm.YL2 := Pointer(YearLabel);
  ProgForm.SLR2 := Pointer(SLRLabel);
  ProgForm.Prot2 := Pointer(ProtectionLabel);
  Update;

end;

procedure TGridForm.StopPausingButtonClick(Sender: TObject);
begin

end;

{----------------------------------------------------------------------------------------------------}

Procedure TGridForm.EditAttributes(NR,NC: Integer; TSS: TSLAMM_Simulation);
Begin
  SS := TSS;
  GridScale := TSS.Site.Scale;

  RunPanel.Visible := False;

  ROSPanel.Visible := TSS.Site.MaxROS > 0;
  ROSShowing := 0;


  MapNR := NR;
  MapNC := NC;

       SRow := 0;
       ERow := MapNR-1;
       SCol := 0;
       ECol := MapNC-1;

  SS.UserStop:=False;

  ProgForm.Show;
  SaveBtStream := True;
  If Not DrawEntireMap(0,True,False) then Exit;
  SS.UserStop:=False;

  EditIndex := 0;
  UpdateEditBox;


  ShowEditItems;
  DefEstClick(nil);

  ZoomBox.Visible := True;
  ZoomBox2.Visible := True;
  ZoomBox3.Visible := True;

  // Form caption with the loaded project name
  Caption :='SLAMM Map -- '+SS.FileN;

  ShowModal;

  if Bitstream <> nil then
    FreeAndNil(BitStream);
End;

{----------------------------------------------------------------------------------------------------}


Procedure TGridForm.UpdateEditBox;
Var i: Integer;
Begin
  EditBox.Items.Clear;

  With SS do
  If DefEst.Checked
    then
      For i := 0 to NumFWFlows-1 do
        EditBox.Items.Add(FWFlows[i].Name)
    else if DefInput.Checked
      then
        For i := 0 to Site.NSubSites-1 do
          EditBox.Items.Add(Site.SubSites[i].Description)
      else
        For i := 0 to Site.NOutputSites-1 do
          EditBox.Items.Add(Site.OutputSites[i].Description);

  EditBox.ItemIndex := EditIndex;
  Updating := True;
  NameEdit.Text := EditBox.Text;
  Updating := False;
{  EditBoxChange(nil); }
End;

procedure TGridForm.ViewLegButtClick(Sender: TObject);
Var ConnectLegend: Boolean;
    GBII: Integer;
begin
  GBII := GraphBox.ItemIndex;
  If GBII = 11 then Begin LegendForm2.ShowModal; Exit; End;   //alternative category legend
  ConnectLegend := (GBII = 12);

  LegendForm.GridColors := SS.GridColors;
  LegendForm.UpdateLegend(GBII>1,GBII=1,ConnectLegend);
  LegendForm.Showmodal;
  If LegendForm.Changed then
    Begin
      SS.GridColors := LegendForm.GridColors;
      SS.AssignGridColors2;
      If MessageDlg('Colors Changed, Redraw Entire Map?',mtconfirmation,[mbyes,mbno],0)=mryes
        then DrawEntireMap(0,true,false);
    End;

  TButton(Sender).Caption:='Legend';
end;

procedure TGridForm.HaltButtonClick(Sender: TObject);
begin
  If MessageDlg('Stop Simulation Execution?',mtconfirmation,[mbyes,mbno],0)=MrYes then
  begin
    ModalResult := MRAbort;            // empty these out
    BitStream := nil;
  end;
end;

procedure TGridForm.HelpButtonClick(Sender: TObject);
begin
  Application.HelpContext(1002);   //Othertools.html
end;

procedure TGridForm.helpFileAttribClick(Sender: TObject);
begin
  Application.HelpContext(1003);  //'SetMap.html');
end;

procedure TGridForm.FormResize(Sender: TObject);
begin
    ScrollBox1.Height:=ClientHeight-Scrollbox1.Top;
    ScrollBox1.Width:=ClientWidth+2;
end;

procedure TGridForm.FormShow(Sender: TObject);
begin
  DisposeWhenClosed := False;

  //AttribPanel.Top := 0;
  MapTitle2.Caption:='';

  SalAnalysis2.Visible := False;
  // Show the salinity analysis button only if a salinity raster is loaded  or fresh water flows have been defined
  if (trim(SS.SalFileN)<>'') or (SS.NumFWFlows>0) then
    SalAnalysis2.Visible := True;

  DrawingRect := False;
  DefiningBoundary := False;
  DefiningVector := False;
  PolyingCells := False;
  DrawingCells:= False;
  FillingCells:= False;
  FillCategory:= False;

  If ZoomFactor = 0.125 then ZoomBox.ItemIndex := 0 else
  If ZoomFactor = 0.25 then ZoomBox.ItemIndex := 1 else
  If ZoomFactor = 0.5 then ZoomBox.ItemIndex := 2 else
  If ZoomFactor = 1 then ZoomBox.ItemIndex := 3 else
  If ZoomFactor = 2 then ZoomBox.ItemIndex := 4 else
  If ZoomFactor = 3 then ZoomBox.ItemIndex := 5;

  ZoomBox2.ItemIndex := ZoomBox.ItemIndex;
  ZoomBox3.ItemIndex := ZoomBox.ItemIndex;

  FormResize(Sender);
end;

procedure TGridForm.FWExtentOnlyClick(Sender: TObject);
begin
  If DefEst.Checked then
    Begin
      If SS.NumFWFlows = 0 then AddEstClick(nil);
      With SS.FWFlows[EditIndex] do
        ExtentOnly := FWExtentOnly.Checked;
    End;


end;

procedure TGridForm.FWFlowButtonClick(Sender: TObject);
begin
  If SS.NumFWFlows = 0 then Exit;
  FWFlowEdit.EditFWFlow(SS.FWFlows,SS.NumFwFlows,EditIndex);
  ShowEditItems;
end;

procedure TGridForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IsVisible:=False;
  LegendForm.Hide;
  ViewLegButt.Caption:='Legend';
  DrawingCells := False;
  PolyingCells := False;
  FillingCells := False;
  //ShowElevs.checked := False;
  If DisposeWhenClosed then
    Begin
      SS.DisposeMem;
      SS.ClearFlowGeometry;
    End;
end;

procedure TGridForm.HideMapButtonClick(Sender: TObject);
begin
  IsVisible :=False;
  LegendForm.Hide;
  ViewLegButt.Caption:='Legend';
  Hide;
end;


{----------------------------------------------------------------------------------------------------}




procedure TGridForm.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var Cl: CompressedCell;
//    SvCrs: TCursor;
    MapX, MapY: Integer;
    Cat: Category;

      {----------------------------------------------------------------------------------------------------}

     Procedure FillPolyCells;
     Var XMin, XMax, YMin, YMax, Xl, Yl, Pl: Integer;
         TempPoly: TPolygon;
         OldCat : Category;

     Begin
       LoadBitStream;

       XMax := -999999;
       XMin :=  999999;
       YMax := -999999;
       YMin :=  999999;

       If NumPolyPts < 3 then exit;

       For Pl := 0 to NumPolyPts-1 do
         Begin
           If PolyPoints[Pl].X > XMax then XMax := PolyPoints[Pl].X;
           If PolyPoints[Pl].Y > YMax then YMax := PolyPoints[Pl].Y;
           If PolyPoints[Pl].X < XMin then XMin := PolyPoints[Pl].X;
           If PolyPoints[Pl].Y < YMin then YMin := PolyPoints[Pl].Y;
         End;

       TempPoly := TPolygon.Create;
       TempPoly.TPoints := PolyPoints;
       TempPoly.NumPts := NumPolyPts;

       For Xl := XMin to XMax do
         For Yl := YMin to YMax do
           If TempPoly.InPoly(Yl,Xl) then
             Begin
               SS.RetA(Yl,Xl,Cl);

               OldCat := GetCellCat(@Cl);
               If FillDikes
                  then
                    Begin
                      Cl.ProtDikes := True;
                      DrawCell(@CL,Yl,Xl,OceanBeach,True,False,False,0);     {draw dikes yellow}
                      DikesChanged := True;
                    End
                  else
                 If FillNoDikes
                  then
                    Begin
                      Cl.ProtDikes := False;
                      DrawCell(@CL,Yl,Xl,OldCat,False,False,False,0);  {remove yellow color}
                      DikesChanged := True;
                    End
                  else
                    Begin
                      SetCellWidth(@Cl,OldCat,0);
                      SetCellWidth(@Cl,CategoryFromComboBox, SS.Site.Scale);
                      DrawCell(@CL,Yl,Xl,CategoryFromComboBox,False,False,False,0);
                      NWIChanged := True;
                    End;

               SS.SetA(Yl,Xl,Cl);
               Image1.Invalidate;
               LastRow := -9999;
             End;

       TempPoly.Destroy;
       SaveBitStream;
       ShowEditItems;
     End;

      {----------------------------------------------------------------------------------------------------}

     Procedure XORPen;
     Begin
        aX := X;
        aY := Y;
        zX := X;
        zY := Y;
        Image1.Canvas.MoveTo(aX,aY);
        Image1.Canvas.Pen.Color := clWhite;
        Image1.Canvas.Pen.Mode := pmXor;
        Image1.Canvas.Brush.Style := bsClear;
        Image1.Canvas.Pen.Width := 1;
        Image1.Canvas.Pen.Style := psSolid;
     End;

      {----------------------------------------------------------------------------------------------------}

     Procedure Fill(FX,FY: Integer; Cat: Category);

        function MP(ax,ay:integer): TPoint;
        begin
          result.x:= ax;
          result.y:= ay;
        end;

     var
      Stack: TPointStack;
      TP: TPoint;

     Begin
       LoadBitStream;

       SS.RetA(FY,FX,Cl);
       If CellWidth(@CL,CAT) > 0.1 then Exit;

       With SS do
         Begin
           stack:= TPointStack.Init;
           stack.push(MP(fx,fy));

           repeat
             TP:= stack.pop;
             if tp.x > -99 then
                begin
                   FX:= TP.x;
                   FY:= TP.y;

                   IF (FY<0) or (FX<0) or (FX>=Site.Cols) or (FY>=Site.Rows) then continue;
                   RetA(FY,FX,Cl);
                   If FillDikes and (CL.ProtDikes) then Continue;        {If filling dikes, exit if Already Protected by Dikes}
                   If FillNoDikes and Not (CL.ProtDikes) then Continue;  {If filling "no dikes", exit if no dikes}
                   If (Not FillNoDikes) then
                     If CellWidth(@CL,FILLCAT) = 0 then Continue;        {Exit if you left the bounds of the FILLCAT}

                   If FillDikes then
                     begin
                        Cl.ProtDikes := True;
                        DikesChanged := True;
                     end
                   else
                   If FillNoDikes then
                     begin
                        Cl.ProtDikes := False;
                        DikesChanged := True;
                     end
                   else
                     begin
                       NWIChanged := True;
                       SetCellWidth(@Cl,FillCat, 0);
                       SetCellWidth(@Cl,Cat, Site.Scale);
                     end;


                   if FillDikes then
                     DrawCell(@Cl,FY,FX,Cat,True,False,False,0) {Draw Yellow}
                   else if FillNoDikes then
                     DrawCell(@Cl,FY,FX,GetCellCat(@CL),False,False,False,0)
                   else
                     DrawCell(@Cl,FY,FX,Cat,False,False,False,0);

                   SetA(FY,FX,Cl);
                   Stack.Push(MP(FX+1,FY));
                   Stack.Push(MP(FX-1,FY));
                   Stack.Push(MP(FX,FY+1));
                   Stack.Push(MP(FX,FY-1));
                   if Checkbox2.Checked then
                   begin
                     Stack.Push(MP(FX+1,FY+1));
                     Stack.Push(MP(FX-1,FY-1));
                     Stack.Push(MP(FX-1,FY+1));
                     Stack.Push(MP(FX+1,FY-1));
                   end;
                end;
           until TP.x = -99;

           Image1.Invalidate;
           LastRow := -9999;
           stack.destroy;
         End;
       SaveBitStream;
     End;

      {----------------------------------------------------------------------------------------------------}

Var i,j: Integer;
    oldcat: Category;
    CE: double;
begin     {Image1MouseDown}

 if (PanCheckBox.Checked) and (not DrawingCells) and (not PolyingCells)
    and (not FillingCells) and (not DefiningBoundary) and (not DefiningVector) then
  begin
    FLastDown := Mouse.CursorPos;
    Screen.Cursor := -21
   end
 else
  begin
   If RunPanel.Visible then exit;

   If DrawingCells then
    Begin
      If (SSRight in Shift) or (SSDouble in Shift) then
        Begin
          DoneDrawingButtonClick(sender);
          Exit;
        End;

      MapX :=Trunc(X/ZoomFactor);
      MapY :=Trunc(Y/ZoomFactor);
      If (MapX>=SS.Site.Cols) or (MapY>=SS.Site.Rows) then exit;

      If (MapX<0) or (MapY<0) then Exit;

      MapX := MapX - (PenWidthBox.ItemIndex div 2);
      If MapX <0 then MapX := 0;
      MapY := MapY - (PenWidthBox.ItemIndex div 2);
      If MapY <0 then MapY := 0;

      With SS do
        For i := 0 to PenWidthBox.ItemIndex do
          For j := 0 to PenWidthBox.ItemIndex do
            Begin
              If (MapX+i>=Site.Cols) or (MapY+j>=Site.Rows) then exit;
              RetA(MapY+i,MapX+j,Cl);
              OldCat := GetCellCat(@Cl);

              If (OldCat = Blank) and (SS.OptimizeLevel > 0) then
                Begin
                  MessageDlg('Cannot Edit Blank Cells when any memory optimization is selected.  Change options in File-Setup.',
                            mterror,[mbok],0);
                  Exit;
                End;

//              LoadBitstream;
              If FillDikes then
                Begin
                  Cl.ProtDikes := True;
                  DrawCell(@CL,MapY+i,MapX+j,OceanBeach,True,False,False,0);     {draw dikes yellow}
                  DikesChanged := True;
                End
              else If FillNoDikes then
                Begin
                  Cl.ProtDikes := False;
                  DrawCell(@CL,MapY+i,MapX+j,OldCat,False,False,False,0);  {remove yellow color}
                  DikesChanged := True;
                End
              else
                Begin
                  // Get elevation category
                  CE := CatElev(@CL,OldCat);

                  SetCellWidth(@Cl,OldCat,0);
                  SetCellWidth(@Cl,CategoryFromComboBox, Site.Scale);

                  // Set the elevation again
                  SetCatElev(@CL,CategoryFromComboBox,CE);

                  DrawCell(@CL,MapY+i,MapX+j,CategoryFromComboBox,False,False,False,0);
                  NWIChanged := True;
                End;

              Image1.Invalidate;
              LastRow := -9999;
              // SaveBitstream;

              SetA(MapY+i,MapX+j,Cl);
            End;

      Exit;
    End;    {DRAWINGCELLS}

    If FillingCells then with SS do
      Begin
        If (SSRight in Shift) or (SSDouble in Shift) then
          Begin
            FillingCells := False;
            MapTitle.Caption:='';
            Exit;
          End;

        Screen.Cursor := crHourglass;

        MapX :=Trunc(X/ZoomFactor);
        MapY :=Trunc(Y/ZoomFactor);
        If (MapX<0) or (MapY<0) then Exit;
        If (MapX>=Site.Cols) or (MapY>=Site.Rows) then exit;

        RetA(MapY,MapX,Cl);
        FILLCAT := GetCellCat(@Cl);

        If (FillCat = Blank) and (SS.OptimizeLevel > 0) then
          Begin
            MessageDlg('Cannot Fill Blanks when any memory optimization is selected.  Change options in File-Setup.',
                        mterror,[mbok],0);
            Screen.Cursor := crdefault;
            Exit;
          End;

        Cat := CategoryFromComboBox;

        Fill(MapX,MapY, Cat);

        Screen.Cursor := crdefault;
        Exit;
      End;    {FILLINGCELLS}

    If DefiningBoundary and PolyingCells then
      Begin
        MapX :=Trunc(X/ZoomFactor);
        MapY :=Trunc(Y/ZoomFactor);

        XORPen;
        Inc(NumPolyPts);
        If NumPolyPts >Length(PolyPoints) then SetLength(PolyPoints,NumPolyPts+100);
        PolyPoints[NumPolyPts-1].X := MapX;
        PolyPoints[NumPolyPts-1].Y := MapY;

        If (SSRight in Shift) or (SSDouble in Shift) then
          Begin
            DefiningBoundary := False;
            Image1.Canvas.MoveTo(aX,aY);
            Image1.Canvas.LineTo(zX,zY);

            FillPolyCells;
            PolyingCells := False;
            DoneDrawingButtonClick(nil);
          End;

        Exit;
      End;      {POLYINGCELLS}

    If DefiningBoundary then With SS do
      Begin
        MapX :=Trunc(X/ZoomFactor);
        MapY :=Trunc(Y/ZoomFactor);

        If (SSRight in Shift) or (SSDouble in Shift) then
          Begin
            DefiningBoundary := False;
            Image1.Canvas.MoveTo(aX,aY);
            Image1.Canvas.LineTo(zX,zY);
            ShowEditItems;
          End;

        If DefEst.Checked then
          With FWFlows[EditIndex].Poly do
            Begin
              XORPen;
              Inc(NumPts);
              If NumPts>Length(TPoints) then SetLength(TPoints,NumPts+100);
              TPoints[NumPts-1].X := MapX;
              TPoints[NumPts-1].Y := MapY;
            End;

        IF Defoutput.Checked then
          With Site.OutputSites[EditIndex] do with rec do //fixme allow for polygon inputs eventually
            Begin
              If (X1<0) and (Y1<0) then
                Begin
                  XORPen;
                  X1 := MapX;
                  Y1 := MapY;
                End
              Else
                Begin
                  Definingboundary := False;
                  X2 := MapX;
                  Y2 := MapY;
                  ShowEditItems;
                End;
            End;


        IF DefInput.Checked then
          With Site.SubSites[EditIndex].Poly do
            Begin
              XORPen;
              Inc(NumPts);
              If NumPts>Length(TPoints) then SetLength(TPoints,NumPts+100);
              TPoints[NumPts-1].X := MapX;
              TPoints[NumPts-1].Y := MapY;
            End;
          Exit;
      End; {defining boundary}

    If DefiningVector then With SS do With FWFlows[EditIndex] do
      Begin
        MapX :=Trunc(X/ZoomFactor);
        MapY :=Trunc(Y/ZoomFactor);

        Image1.Canvas.MoveTo(X-1,Y-1);
        Image1.Canvas.LineTo(X-1,Y+1);
        Image1.Canvas.LineTo(X+1,Y+1);
        Image1.Canvas.LineTo(X+1,Y-1);

        If (SSRight in Shift) or (SSDouble in Shift) then
          Begin
            DefiningVector := False;
            Image1.Canvas.MoveTo(aX,aY);
            Image1.Canvas.LineTo(zX,zY);
            ShowEditItems;
            Exit;
          End;

        With FWFlows[EditIndex] do
          Begin
            XORPen;

            If NextOriginX > 0 then
              Begin
                Inc(NumSegments);
                If NumSegments>Length(OriginArr) then
                  Begin
                    SetLength(OriginArr,NumSegments+20);
                    SetLength(MouthArr,NumSegments+20);
                  End;

                MouthArr[NumSegments-1].X := MapX;
                MouthArr[NumSegments-1].Y := MapY;
                OriginArr[NumSegments-1].X := NextOriginX;
                OriginArr[NumSegments-1].Y := NextOriginY;
              End;

            NextOriginX := MapX;
            NextOriginY := MapY;
          End;
        Exit;
      End;  {defining vector}

    if (Button = mbLeft) and (ToolBox1.ItemIndex >-1) and (ToolBox1.ItemIndex<2) then
      begin
        DrawingRect := TRUE;
        XORPen;
      end;
   end;
end;


{----------------------------------------------------------------------------------------------------}


procedure TGridForm.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
Var MapX,MapY,lngth: Integer;
    Cl: CompressedCell;
    OldCat: Category;
    pt: TPoint;
    PSS: TSubSite;
    RSeg : Integer;
    DirStr  : String;
    D2C,RKM  : Double;

    {----------------------------------------------------------------------------------------------------}
    Procedure PanMap;
    begin
      if (not (ssLeft in Shift)) or (FLastDown.X<0) Then exit;
      pt := Mouse.CursorPos;
      Scrollbox1.VertScrollBar.Position :=
      Scrollbox1.VertScrollBar.Position + FLastDown.Y - pt.Y;
      Scrollbox1.HorzScrollBar.POsition :=
      Scrollbox1.HorzScrollBar.Position + FLastDown.X - pt.X;
      FLastDown:= pt;
    end;
    {----------------------------------------------------------------------------------------------------}
    Procedure DrawCells;
    Var i,j: Integer;
    Begin
      If (SSRight in Shift) or (SSDouble in Shift) then
        Begin  DrawingCells := False; MapTitle.Caption:=''; Exit;  End;

      If SSLeft in Shift then with SS do
        Begin
          MapX :=Trunc(X/ZoomFactor);
          MapY :=Trunc(Y/ZoomFactor);
          If (MapX>=Site.Cols) or (MapY>=Site.Rows) then exit;
          If (MapX<0) or (MapY < 0) then exit;

          MapX := MapX - (PenWidthBox.ItemIndex div 2);
          If MapX <0 then MapX := 0;
          MapY := MapY - (PenWidthBox.ItemIndex div 2);
          If MapY <0 then MapY := 0;

          For i := 0 to PenWidthBox.ItemIndex do
           For j := 0 to PenWidthBox.ItemIndex do
             Begin
              If (MapX+i>=Site.Cols) or (MapY+j>=Site.Rows) then exit;
              RetA(MapY+i,MapX+j,Cl);
              OldCat := GetCellCat(@Cl);

              If (OldCat = Blank) and (SS.OptimizeLevel > 0) then
                  Begin
                    MessageDlg('Cannot Edit Blank Cells when any memory optimization is selected.  Change options in File-Setup.',
                                mterror,[mbok],0);
                    Exit;
                  End;

              If FillDikes
                then
                  Begin
                    Cl.ProtDikes := True;
                    DrawCell(@CL,MapY+i,MapX+j,OceanBeach,True,False,False,0);     {draw dikes yellow}
                    DikesChanged := True;
                  End
                else
               If FillNoDikes
                then
                  Begin
                    Cl.ProtDikes := False;
                    DrawCell(@CL,MapY+i,MapX+j,OldCat,False,False,False,0);  {remove yellow color}
                    DikesChanged := True;
                  End
                else
                  Begin
                    SetCellWidth(@Cl,OldCat,0);
                    SetCellWidth(@Cl,CategoryFromComboBox, Site.Scale);
                    DrawCell(@CL,MapY+i,MapX+j,CategoryFromComboBox,False,False,False,0);
                    NWIChanged := True;
                  End;

              Image1.Invalidate;
              LastRow := -9999;
//            SaveBitStream;

              SetA(MapY+i,MapX+j,Cl);
            End;
          exit;
        End;
    End;  {DrawCells}
    {----------------------------------------------------------------------------------------------------}
    Procedure DrawLine;
    Begin
      Image1.Canvas.MoveTo(aX,aY);
      Image1.Canvas.LineTo(zX,zY);
      ZX := X; ZY := Y;
      Image1.Canvas.MoveTo(aX,aY);
      Image1.Canvas.LineTo(zX,zY);
    End;
    {----------------------------------------------------------------------------------------------------}
    Procedure DrawRect;
    Begin
     with SS.Site.OutputSites[EditIndex] do with rec do
      Begin
        If (x1 = -99) then Exit;

        Image1.Canvas.MoveTo(aX,aY);
        Image1.Canvas.LineTo(zX,aY);
        Image1.Canvas.LineTo(zX,zY);
        Image1.Canvas.LineTo(aX,zy);
        Image1.Canvas.LineTo(aX,aY);

        ZX := X; ZY := Y;
        Image1.Canvas.MoveTo(aX,aY);
        Image1.Canvas.LineTo(zX,aY);
        Image1.Canvas.LineTo(zX,zY);
        Image1.Canvas.LineTo(aX,zy);
        Image1.Canvas.LineTo(aX,aY);
      End;
    End;
    {----------------------------------------------------------------------------------------------------}
    Procedure DrawCellinfoBox;
    Var CatLoop: Category;
        i: Integer;
    Begin
      with SS do
        Begin
          Memo1.Visible := True;

          If (ToolBox1.ItemIndex=2) then Memo1.Height := 150
                                    else Memo1.Height := 320;

          {LOCATE MEMO BOX}
          pt.x := x-ScrollBox1.HorzScrollBar.Position+5;
          pt.y := y-ScrollBox1.VertScrollBar.Position+5;
          If (pt.y + memo1.height) > ScrollBox1.Height then
             pt.y := pt.y - memo1.height;
          If (pt.x + memo1.width) > ScrollBox1.width then
             pt.x := pt.x - memo1.width;

          If (Memo1.Top = pt.y) and (Memo1.Left=pt.x) then exit;

          Memo1.Top := pt.y;
          Memo1.Left := pt.x;
          {/ LOCATE MEMO BOX}

          If (ToolBox1.ItemIndex=2) then
            Begin
              PSS := Site.GetSubSite(MapX,MapY,@Cl);

              {WRITE ON MEMO BOX}
              Memo1.Lines.Clear;
              For CatLoop := FirstCategory to LastCategory do
                If CellWidth(@CL,CatLoop)>0 then
                  Memo1.Lines.Add('Width '+TitleCat[CatLoop]+' '+FloatToStrF(CellWidth(@CL,CatLoop),ffgeneral,4,4)+'m');
              Memo1.Lines.Add('-------------------');
              For CatLoop := FirstCategory to LastCategory do
               If CatLoop<>Blank then
                If CellWidth(@CL,CatLoop)>0 then
                  Memo1.Lines.Add('MinElev '+TitleCat[CatLoop]+' '+FloatToStrF(Catelev(@CL,CatLoop),ffgeneral,4,4)+'m');
              Memo1.Lines.Add('-------------------');
              Memo1.Lines.Add('Tanslope '+FloatToStrF(CL.TanSlope,ffgeneral,4,4)+' m/m');
              If SS.NumFWFlows>0 then
                Begin
                  Memo1.Lines.Add('Sal. MLLW (ppt)  '+FloatToStrF(CL.Sal[1],ffgeneral,4,4));
    //              Memo1.Lines.Add('Sal. MTL (ppt)  '+FloatToStrF(CL.Sal[2],ffgeneral,4,4));
                  Memo1.Lines.Add('Sal. MHHW (ppt)  '+FloatToStrF(CL.Sal[3],ffgeneral,4,4));
                  Memo1.Lines.Add('Sal. 30D (ppt)  '+FloatToStrF(CL.Sal[4],ffgeneral,4,4));
                End;

              If  CL.D2Channel >=0 then Memo1.Lines.Add('D2Channel '+FloatToStrF(Cl.D2Channel,ffgeneral,4,4)+' m');

    //         If (CL.ProtDikes) then Memo1.Lines.Add('DikeIndex '+IntToStr(CL.DikeIndex));
              If CL.MaxFetch>=0 then Memo1.Lines.Add('Max Fetch '+FloatToStrF(Cl.MaxFetch,ffgeneral,4,4)+' km');

               If  (CellWidth(@CL,RegFloodMarsh) > 0) then
                   Memo1.Lines.Add('Reg. Flood Accr '+ FloatToStrF(RegFloodAccrete(@CL,PSS),ffgeneral,4,4)+' mm/yr');
               If  (CellWidth(@CL,IrregFloodMarsh) > 0) or (CellWidth(@CL,ScrubShrub) > 0) then
                   Memo1.Lines.Add('Irreg. Flood Accr '+ FloatToStrF(IrregFloodAccrete(@CL,PSS),ffgeneral,4,4)+' mm/yr');
               If  (CellWidth(@CL,TidalFlat) > 0) or (CellWidth(@CL,OceanFlat) > 0) then
                   Memo1.Lines.Add('T.Flat Accr '+ FloatToStrF(TidalFlat_Sed(@CL,PSS),ffgeneral,4,4)+' mm/yr');
               If  (CellWidth(@CL,VegTidalFlat) > 0) then
                   Memo1.Lines.Add('Veg.T.Flat Accr '+ FloatToStrF(TidalFlat_Sed(@CL,PSS),ffgeneral,4,4)+' mm/yr');
               If  (CellWidth(@CL,OceanBeach) > 0) or (CellWidth(@CL,EstuarineBeach) > 0) then
                   Memo1.Lines.Add('Beach Accr '+ FloatToStrF(PSS.Fixed_TF_Beach_Sed,ffgeneral,4,4)+' mm/yr');
               If  (CellWidth(@CL,InlandFreshMarsh) > 0) then
                   Memo1.Lines.Add('Fresh Accr '+ FloatToStrF(PSS.InlandFreshAccr,ffgeneral,4,4)+' mm/yr');
               If  (CellWidth(@CL,TidalFreshMarsh) > 0)  then
                   Memo1.Lines.Add('T.Fresh Accr '+ FloatToStrF(TidalFreshAccrete(@CL,PSS),ffgeneral,4,4)+' mm/yr');

               If  (CellWidth(@CL,TidalSwamp) > 0) or (CellWidth(@CL,InlandFreshMarsh) > 0) then
                   Memo1.Lines.Add('Tidal Swamp Accr '+ FloatToStrF(PSS.TSwampAccr,ffgeneral,4,4)+' mm/yr');
               If  (CellWidth(@CL,Swamp) > 0) or (CellWidth(@CL,CypressSwamp) > 0) then
                   Memo1.Lines.Add('Swamp Accr '+ FloatToStrF(PSS.SwampAccr,ffgeneral,4,4)+' mm/yr');
               If  (CellWidth(@CL,Mangrove) > 0) then
                   Memo1.Lines.Add('Mangrove Accr '+ FloatToStrF(PSS.MangroveAccr,ffgeneral,4,4)+' mm/yr');

               If SS.UpliftFileN <> '' then
                   Memo1.Lines.Add('Uplift '+ FloatToStrF(CL.Uplift,ffgeneral,4,4)+' cm/yr');

               If CL.ErosionLoss > 0 then
                   Memo1.Lines.Add('Marsh or Swamp Erosion Loss '+ FloatToStrF(CL.ErosionLoss,ffgeneral,4,4)+' m');
               If CL.BTFErosionLoss > 0 then
                   Memo1.Lines.Add('Beach or T.Flat Erosion '+ FloatToStrF(CL.BTFErosionLoss,ffgeneral,4,4)+' m');

               Memo1.Lines.Add('MTL-NAVD88 '+ FloatToStrF(CL.MTLminusNAVD ,ffgeneral,4,4)+' m');

               IF Cl.D2MLLW > -9998 then
                  Memo1.Lines.Add('D2MLLW '+ FloatToStrF(CL.D2MLLW ,ffgeneral,4,4)+' m');

               IF Cl.D2MHHW > -9998 then
                  Memo1.Lines.Add('D2MHHW '+ FloatToStrF(CL.D2MHHW ,ffgeneral,4,4)+' m');

               IF Cl.ProbSAV > -9998 then
                  Memo1.Lines.Add('ProbSAV '+ FloatToStrF(CL.ProbSAV ,ffgeneral,4,4)+' frac');


              {WRITE ON MEMO BOX}
            End; {=2}

          If (ToolBox1.ItemIndex=3) then
            Begin
              PSS := Site.GetSubSite(MapX,MapY);
              With PSS do
                Begin
                  Memo1.Lines.Clear;
                  If PSS = Site.GlobalSite then Memo1.Lines.Add('** GLOBAL SITE ** ')
                                           else Memo1.Lines.Add('-- subsite --');
                  Memo1.Lines.Add('Desc: '+Description);
                  Memo1.Lines.Add('NWI Date: '+IntToSTr(NWI_Photo_Date));
                  Memo1.Lines.Add('DEM Date: '+IntToSTr(DEM_Date));
                  Case Direction_OffShore of
                     Southerly: DirStr := 'Southerly';
                     Northerly: DirStr := 'Northerly';
                     Easterly: DirStr := 'Easterly';
                     Westerly: DirStr := 'Westerly';
                   end{Case};
                  Memo1.Lines.Add('DirOffShore: '+DirStr);
                  Memo1.Lines.Add('MTL-NAVD88 (m): '+FloatToSTrF(NAVD88MTL_correction,ffgeneral,6,4));
                  Memo1.Lines.Add('GT Tide Range: '+FloatToSTrF(GTideRange,ffgeneral,6,4));
                  Memo1.Lines.Add('Salt Elev. (m): '+FloatToSTrF(SaltElev,ffgeneral,6,4));

                  If SS.UpliftFileN = '' then
                    Memo1.Lines.Add('Hist.trend (mm/yr): '+FloatToSTrF(Historic_trend,ffgeneral,6,4));

                  If UseAccrModel[0]
                    then Memo1.Lines.Add('Reg Flood -- DYNAMIC ACCR. MODEL')
                    else Memo1.Lines.Add('RegFloodAccrete (mm/yr): '+FloatToSTrF(FixedRegFloodAccr ,ffgeneral,6,4));
                  If UseAccrModel[1]
                    then Memo1.Lines.Add('Irreg Flood -- DYNAMIC ACCR. MODEL')
                    else Memo1.Lines.Add('IrregFloodAccrete (mm/yr): '+FloatToSTrF(FixedIrregFloodAccr ,ffgeneral,6,4));
                  Memo1.Lines.Add('Beach_Sed (mm/yr): '+FloatToStrF(Fixed_TF_Beach_Sed,ffgeneral,8,4));
                  If UseAccrModel[2]
                    then Memo1.Lines.Add('T.Flat -- DYNAMIC ACCR. MODEL');
                  If UseAccrModel[3]
                    then Memo1.Lines.Add('Tidal Fresh -- DYNAMIC ACCR. MODEL')
                    else Memo1.Lines.Add('Tidal Fresh Accrete (mm/yr): '+FloatToSTrF(FixedTideFreshAccr ,ffgeneral,6,4));

                  Memo1.Lines.Add('Inland Fresh Accrete (mm/yr): '+FloatToSTrF(InlandFreshAccr ,ffgeneral,6,4));
                  Memo1.Lines.Add('Mangrove Accrete (mm/yr): '+FloatToSTrF(MangroveAccr ,ffgeneral,6,4));
                  Memo1.Lines.Add('Swamp Accrete (mm/yr): '+FloatToSTrF(SwampAccr ,ffgeneral,6,4));
                  Memo1.Lines.Add('TSwamp Accrete (mm/yr): '+FloatToSTrF(TSwampAccr ,ffgeneral,6,4));

                  Memo1.Lines.Add('MarshErosion (m/yr): '+FloatToStrF(MarshErosion,ffgeneral,8,4));
                  Memo1.Lines.Add('SwampErosion (m/yr): '+FloatToStrF(SwampErosion,ffgeneral,8,4));
                  Memo1.Lines.Add('TFlatErosion (m/yr): '+FloatToStrF(TFlatErosion,ffgeneral,8,4));
                  If Use_Preprocessor then Memo1.Lines.Add('** ELEV. PREPROCESSOR USED **');
                End; {With PSS}
            End; {=3}

          If (ToolBox1.ItemIndex=4) then
            Begin
              {WRITE ON MEMO BOX}
              Memo1.Lines.Clear;
              Memo1.Lines.Add('');;

              If not FWInfluenced(MapY, MapX)
                then Memo1.Lines.Add('No Freshwater Influence')
                else
                  For i := 0 to (NumFWFlows-1) do
                   if FWInfluenced(MapY, MapX,i) then
                    With FWFlows[i] do
                    Begin
                      Memo1.Lines.Add('FWFlow Name '+Name);
                      If ExtentOnly then Memo1.Lines.Add('  Freshwater Extent Defined Only')
                      else If Length(NumCells) = 0
                        then Memo1.Lines.Add('  Salinity Not Initialized')
                        else
                          Begin
                            RKM := RiverKM(MapY,MapX,i,D2C);

                            Memo1.Lines.Add('RiverKM '+FloatToStrF(RKM,ffgeneral,8,4));
    //                      Memo1.Lines.Add('D2 Chan. '+FloatToStrF(D2C,ffgeneral,8,4));
                            RSeg :=  Trunc (RKM / SliceIncrement);          {calculate the river segment index for this cell}
                            Memo1.Lines.Add('RSeg '+IntToStr(RSeg));
                            Memo1.Lines.Add('RetTime MLLW '+FloatToStrF(RetTime[1,RSeg],ffgeneral,8,4));
                            Memo1.Lines.Add('WaterZ MLLW '+FloatToStrF(WaterZ[1,RSeg],ffgeneral,8,4));
                            Memo1.Lines.Add('SaltWedge Z MLLW '+FloatToStrF(CL.SalHeightMLLW,ffgeneral,4,4));

    //                      Memo1.Lines.Add('SaltWedge Z MTL '+FloatToStrF(SaltHeight(0,RSeg),ffgeneral,4,4));
                            Memo1.Lines.Add('-- Vol Below MLLW '+FloatToStrF(VolumeByElev(-1.025,RSeg),ffgeneral,4,4));
                            Memo1.Lines.Add('-- SegSalin MLLW '+FloatToStrF(XS_Salinity[1,RSeg],ffgeneral,4,4));
    //                      Memo1.Lines.Add('RetTime MLLW '+FloatToStrF(RetTime[1,RSeg],ffgeneral,8,4));
    //                      Memo1.Lines.Add('WaterZ MLLW '+FloatToStrF(WaterZ[1,RSeg],ffgeneral,8,4));

                            Memo1.Lines.Add('Seg N Cells '+IntToStr(NumCells[RSeg]));
                            Memo1.Lines.Add('');
                          End;
                    End;

              {WRITE ON MEMO BOX}
            End; {=4}


          DepthLabel.Caption := 'Elev: '+FloatToStrF(GetMinElev(@Cl,MapY,MapX) ,ffgeneral,8,4) ;
          CategoryLabel.Caption := TitleCat[GetCellCat(@Cl)];
          XLabel2.Caption := 'X '+IntToStr(MapX);
          YLabel2.Caption := 'Y '+IntToStr(MapY);
          update;
          Exit;
        End;  {With SS}
    End;  {DrawCellinfoBox; }
    {----------------------------------------------------------------------------------------------------}
    Procedure DrawRect2;
    Begin
      with SS do
         begin
          Image1.Canvas.Rectangle(aX,aY,zX,zY);
          zX := X;
          zY := Y;
          If ToolBox1.ItemIndex=0 then   {profile tool selected}
              If ABS(zX-aX) > ABS(zY-aY)
                then zY := aY+2
                else zX := aX+2;
          Image1.Canvas.Rectangle(aX,aY,zX,zY);
          wd := abs(zX-aX);  // Width of rect - for status bar
          ht := abs(zY-aY);  // Height of rect

          Lngth := Round(Max(wd,ht)*ThisSite.Scale/ZoomFactor);
          If ToolBox1.ItemIndex =0 then StatLabel.Caption := 'length '+IntToStr(Lngth)+'M'
                                   else StatLabel.Caption := '';
        end;
    End;
    {----------------------------------------------------------------------------------------------------}

Var Page0: Boolean;
begin  {Image1MouseMove}

  MapX :=Trunc(X/ZoomFactor);    // Get MapX and MapY from screen coordinates
  MapY :=Trunc(Y/ZoomFactor);
  If (MapX>=SS.Site.Cols) or (MapY>=SS.Site.Rows) then exit;
  If (MapX<0) or (MapY<0) then Exit;

  SS.RetA(MapY,MapX,Cl);   // Get the cell and display the X, Y, Elevation, and Category
  XLabel2.Caption := 'X '+IntToStr(MapX);
  YLabel2.Caption := 'Y '+IntToStr(MapY);
  DepthLabel.Caption := 'Elev: '+FloatToStrF(GetMinElev(@Cl,MapY,MapX) ,ffgeneral,8,4) ;
  CategoryLabel.Caption := TitleCat[GetCellCat(@Cl)];

  Page0 := PageControl1.ActivePageIndex=0;
  if not (ToolBox1.Visible) or (Toolbox1.ItemIndex in [2..4]) then Memo1.Visible := False;

  // Handle the appropriate action for the selected tool
  if PanCheckBox.Checked and (not DrawingCells) and (not PolyingCells)
                         and (not FillingCells) and (not DefiningBoundary) and (not DefiningVector)
    then PanMap
    else If not (ToolPanel.Visible or PageControl1.Pages[0].TabVisible) then exit
      else if DrawingCells then DrawCells
      else if DefiningBoundary and ((not Page0) or (not DefOutput.Checked)) then
        Begin
          if Page0 then
            Begin
              if (DefInput.Checked) then if (SS.Site.SubSites[EditIndex].Poly.NumPts = 0) then exit;
              If (DefEst.Checked) then if (SS.FWFlows[EditIndex].Poly.NumPts = 0) then Exit;
            End;
          if PolyingCells and (NumPolyPts = 0) then Exit;
          DrawLine;
        End
      else If (DefEst.Checked) and DefiningVector and (NextOriginX >= 0) then DrawLine
      else If DefOutput.Checked and DefiningBoundary then DrawRect
      else If not ToolPanel.Visible then exit
      else If (ToolBox1.ItemIndex in [2..4]) then DrawCellInfoBox
      else if DrawingRect then DrawRect2;
end;  {Image1MouseMove}

{----------------------------------------------------------------------------------------------------}


Procedure TGridForm.Graph3D;
Var  // MapSurface: TSurface;
    Subs: TSubsite;
    GridX, GridY: Integer;
    ix,iy: Integer;
    Cl:CompressedCell;
    ZMx, ZMn : Double;
    MapZn, XMn, XMx, YMn, YMx: Integer;
    Elev: Double;
    Catg: Category;

Begin
Try
  Application.CreateForm(TDelphi3dForm,Delphi3dForm);
Except
  Raise ESLAMMError.Create('Error, video card may not support OpenGL.');
  Exit;
End;
//  Application.CreateForm(TDotDispModeDlg,DotDispModeDlg);

  GridX := Abs(aX-zX);
  GridY := Abs(aY-zY);
  Zmx := -999999;
  Zmn := 999999;
  Xmn := Min(aX,zX);
  Ymn := Min(aY,zY);
  XMx := Max(aX,zX);
  YMx := Max(aY,zY);

  If (GridX=0) or (GridY=0) then exit;

  // Set the camera transform:
  with delphi3dform do  {glDraw}
  begin

  SetupForm;

  NX := XMx - XMn + 1;
  NY := YMx - YMn + 1;
  SetLength(MapZs,NX*NY);
  SetLength(MapColors,NX*NY);
  Subs := SS.Site.GetSubSite((Xmn+Xmx) Div 2,(Ymn+Ymx) Div 2);
  SS.Site.InitElevVars;
  With SS do
   Begin
    MHWSz := (Subs.SaltElev)/site.scale;           // ECL salt elevation
    MHHWz := (Subs.MHHW)/site.scale;
    MLLWz := (Subs.MLLW)/site.scale;
   End;  {Fixme, adjust by subsite?}

  MapZn := -1;
  With SS do
  For ix := XMn to XMx do
    For iy := Ymn to YMx do
      Begin
        RetA(iY,iX,CL);                           // grabbing cell from nwi array
        CatG := Category(GetCellCat(@Cl));         //  grabbing dominant category of cell
        Elev := GetMinElev(@Cl,iY,iX);              // '' '' ' category elevation
        If Elev > ZMx then ZMx := Elev/site.scale;   // seeting max elevation
        If Elev < ZMn then ZMn := Elev/site.scale;   // setting min elev

        Inc(MapZn);
        if elev = 999
          then MapZs[MapZn] := Elev                   // creating elevaiton array
          else MapZs[MapZn] := Elev/Site.scale;
        MapColors[MapZn] := GridColors[CatG];         // creating color array
      End;

   ShowModal;

  end;

  delphi3dform.Free;
//  DotDispModeDlg.Free;
End;

procedure TGridForm.GraphBoxChange(Sender: TObject);
Var DotSizeShown: Boolean;
begin
//  If MessageDlg('Redraw Entire Map?',mtconfirmation,[mbyes,mbno],0)=mrno then Exit;

  ZoomFactor := ZF_From_Screen;

  Case GraphBox.ItemIndex of
    0: LegendForm.TitleLabel.Caption := 'SLAMM Categories';
    1: LegendForm.TitleLabel.Caption := 'Elevations, relative to MTL';
    2..5:  LegendForm.TitleLabel.Caption := 'Salinity, ppt';
    6:   LegendForm.TitleLabel.Caption := 'Accretion, mm/year';
    7:   LegendForm.TitleLabel.Caption := 'Subsidence, mm/year';
    8:   LegendForm.TitleLabel.Caption := 'MTL Corr, m';
    9:   LegendForm.TitleLabel.Caption := 'Marsh/Swamp Erosion, m';
    10:   LegendForm.TitleLabel.Caption := 'Beach/T.Flat Erosion, m';
    12:   LegendForm.TitleLabel.Caption := 'Connectivity';

  End; {Case}

  DrawingTopLayer := False;

  DotSizeShown := GraphBox.ItemIndex in [9,10];
  DotSizeBox.Visible := DotSizeShown;
  DotSizeLabel.Visible := DotSizeShown;

  if GraphBox.ItemIndex = 12 then
    ShowDikesOrConnect(True)
  else
    begin
      DrawEntireMap(0,true,false);
      ShowDikes.Checked := False;
    end;
end;

{----------------------------------------------------------------------------------------------------}

procedure TGridForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
    i, ArrL, xmin,xmax,ymin,ymax, CellX, CellY, ScrAX, ScrAY, ScrZX, ScrZY: Integer;
    Cl:CompressedCell;
begin
  if PanCheckBox.Checked and (not DrawingCells) and (not PolyingCells)
        and (not FillingCells) and (not DefiningBoundary) and (not DefiningVector)  then
    Screen.Cursor := -2
  else
  begin

  If DrawingCells then SaveBitStream;
  If RunPanel.Visible then exit;

with SS do
 Begin
  If Not DrawingRect then Exit;

  DrawingRect := FALSE;
  zX := X;
  zY := Y;

  ScrAX := ax;
  ScrAY := ay;
  ScrzX := zx;
  Scrzy := zy;

  aX := Trunc(ax/ZoomFactor);
  aY := Trunc(aY/ZoomFactor);
  zX := Trunc(zX/ZoomFactor);
  zY := Trunc(zY/ZoomFactor);

  If  ToolBox1.ItemIndex=1 then
    Begin
     Graph3D;
     Image1.Canvas.Rectangle(ScraX,ScraY,ScrzX,ScrzY);
     Image1.Canvas.Pen.Style := psSolid;
     exit;
    End;

  If ABS(zX-aX) > ABS(zY-aY)
     then zY := aY
     else zX := aX;

  wd := abs(zX-aX);  // Width
  ht := abs(zY-aY);  // Height
  ArrL := Max(Wd,ht)+1;

  With ProfileForm do
    Begin
      MinProfile := nil;
      ColorProfile := nil;
      SetLength(MinProfile,ArrL);
      SetLength(ColorProfile,ArrL);
    End;

    Xmin := Min(aX,zX);
    Ymin := Min(aY,zY);
    XMax := Max(aX,zX);
    YMax := Max(aY,zY);

    i:=0;
    For CellX := XMin to XMax do
      For CellY := Ymin to YMax do
        Begin
          RetA(CellY,CellX,CL);

          ProfileForm.MinProfile[i]:=GetMinElev(@Cl,CellY,CelLX);
          ProfileForm.ColorProfile[i]:=GridColors[GetCellCat(@Cl)];
          inc(i);
        End;

  ProfileForm.ReverseAspect := False;
  ProfileForm.Scale := GridScale;
  ProfileForm.DrawProfile;
  ProfileForm.ShowModal;

  If ToolBox1.ItemIndex=0 then
     If ABS(ScrzX-ScraX) > ABS(ScrzY-ScraY)
        then ScrzY := ScraY+2
        else ScrzX := ScraX+2;
  Image1.Canvas.Rectangle(ScraX,ScraY,ScrzX,ScrzY);
  Image1.Canvas.Pen.Style := psSolid;
 End;

  end;
end;

{----------------------------------------------------------------------------------------------------}

procedure TGridForm.FillDikesBoxClick(Sender: TObject);
begin

  FillDikes:= FillDikesBox.Checked;

  If FillDikes then FillNoDikes := False;
  If FillDikes then FillNoDikesBox.Checked := False;

  CategoryBox.Enabled := Not FillDikes and Not FillNoDikes;

end;

procedure TGridForm.FillDryLandButtonClick(Sender: TObject);
var
 ER, EC: integer;
 CL: Compressedcell;
 CC: Category;
 CE: double;

begin

  If MessageDlg('Are you sure you want to fill blanks cells as dry land?',mtconfirmation,[mbyes,mbno],0)=Mrno then Exit;

  ProgForm.Show;

  ProgForm.ProgressLabel.Caption := 'Filling Dry Land';
  with SS do
   for ER :=0 to MapNR- 1 do
    for EC:=0 to MapNC-1 do
      begin

        // Get the cell
        RetA(ER,EC,CL);

        // Get cell category
        CC := GetCellCat(@CL);

        // Get elevation category
        CE := CatElev(@CL,CC);

        if (CE <> Site.NoElevData ) and (CC=blank) and (CE <> 999) then
        begin
          ProgForm.Update2Gages(Trunc(100*(ER*MapNC+EC)/(MapNR*MapNC)));

          // How to change the categories
          SetCellWidth(@CL,blank,0);  {loss first to minimize data loss due to compression}

          if CL.ImpCoeff> 25 then
            begin
              SetCellWidth(@CL,devdryland,gridscale);
              SetCatElev(@CL,devdryland,CE);
            end
          else
            begin
              SetCellWidth(@CL,unddryland,gridscale);
              SetCatElev(@CL,unddryland,CE);
            end;

              // Set cell
              SetA(ER,EC,CL);

              //DrawCell(@CL,ER,EC,blank,False,False,False);
              NWIChanged := True
            end;

		// Used for eliminating mangroves
(*          if CL.Cats[1]=mangrove then

            begin
              SetCellWidth(@CL,mangrove,0);
              SetCellWidth(@CL,ScrubShrub,gridscale);
              SetA(ER,EC,CL);
              NWIChanged := True;
            end; *)
        end;

    ProgForm.Cleanup;

    if NWIChanged=True then
      DrawEntireMap(0,True,False);

{*   if GridForm.NWIChanged then
    begin
      if PromptforFileName(pName,'ASC Files (*.ASC)|*.ASC','','Save your grid file','',True) then
      begin
        pName := ChangeFileExt(pName,'.ASC');
        SS.SaveRaster(pName,2 );
        SS.NWIFileN := pName;
      end;
    end;
*}
    //GridForm.NWIChanged := False;

    //MainForm.SaveSimClick(Sender);

      // Change the NWI raster
      // Redraw on the fly (inside if) or at the end

end;

procedure TGridForm.FillNoDikesBoxClick(Sender: TObject);
begin
  FillNoDikes:= FillNoDikesBox.Checked;

  If FillNoDikes then FillDikes := False;
  If FillNoDikes then FillDikesBox.Checked := False;

  CategoryBox.Enabled := Not FillDikes and Not FillNoDikes;

end;

function TGridForm.CategoryFromComboBox: Category;
begin
      case CategoryBox.ItemIndex of
        0 : Result:= DevDryland;
        1 : Result:= UndDryland;
        2 : Result:= Swamp;
        3 : Result:= CypressSwamp;
        4 : Result:= InlandFreshMarsh;
        5 : Result:= TidalFreshMarsh ;
        6 : Result:= ScrubShrub;
        7 : Result:= RegFloodMarsh;
        8 : Result:= Mangrove;
        9 : Result:= EstuarineBeach;
        10: Result:= TidalFlat;
        11: Result:= OceanBeach;
        12: Result:= OceanFlat;
        13: Result:= RockyIntertidal;
        14: Result:= InlandOpenWater;
        15: Result:= RiverineTidal;
        16: Result:= EstuarineWater;
        17: Result:= TidalCreek;
        18: Result:= OpenOcean;
        19: Result:= IrregFloodMarsh;
        20: Result:= InlandShore;
        21: Result:= TidalSwamp;
        22: Result:= Blank;
        23: Result:= VegTidalFlat;
        24: Result:= BackShore;
        else Result:= Blank;
      end;

end;

Procedure TGridForm.SaveMapToGIF(FileN: String);
var SaveGIF : TGIFImage;
    FN: String;
    FIter:Integer;

begin
  SaveGIF := TGIFImage.Create;
  try
    SaveGIF.Assign(Image1.Picture.Bitmap);
    FN := FileN + '.gif';   
    FIter := 0;
    While FileExists(FN) do
      Begin
        Inc(FIter);
        FN := FileN+IntToStr(FIter)+'.gif';
      End;
    SaveGIF.SaveToFile(FN);
  finally
    SaveGIF.Free;
  end;
end;



procedure TGridForm.SaveSubsitesButtonClick(Sender: TObject);
var
  pName: String;
begin
    if PromptforFileName(pName,'ASC Files (*.ASC)|*.ASC','','Save your grid file','',True) then
      begin
        pName := ChangeFileExt(pName,'.ASC');
        SS.SaveRaster(pName,4 );
      end;
end;

procedure TGridForm.ScrollBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   DepthLabel.Caption := '';
   xlabel2.Caption := '';
   ylabel2.Caption := '';
   CategoryLabel.Caption := '';
   Memo1.Visible := False;
end;

procedure TGridForm.CopyMapToClipboard(Sender: TObject);
Begin
  ClipBoard.Assign(Image1.Picture);
end;

procedure TGridForm.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  If (X<>0) or (Y<>0) then memo1.visible := False;
end;

Procedure TGridForm.ShowDikesOrConnect(ShowConnect:Boolean);
Var Cat: Category;
    DrawRow, DrawCol, ER, EC: Integer;
    CL: CompressedCell;
    Finished, Redraw, DrawDike: Boolean;
    ShowingDikes: Boolean;

begin
  ShowingDikes := ShowDikes.Checked;

  GridForm.Image1.Canvas.Pen.Mode := pmcopy;

  Screen.Cursor := crHourglass;

  //Calculate connectivity
  if (ShowConnect) then
    begin
      ShowRunPanel;
      ProgForm.YearLabel.Visible       := False;
      ProgForm.SLRLabel.Visible        := False;
      ProgForm.ProtectionLabel.Visible := False;
      ProgForm.ProgressLabel.Caption   := 'Checking Connectivity';

      Finished := True;
      If SS.Connect_Array = nil then Finished := SS.Calc_Connectivity(-1,-1);  // Only calculate connectivity if it hasn't already been calculated

      ProgForm.Hide;
      RunPanel.Visible := False;
      if (not Finished) then
        begin
          SS.Connect_Array := nil;
          Exit;
        end;
    end;

  //Updating the map
  ShowRunPanel;
  ProgForm.YearLabel.Visible       := False;
  ProgForm.SLRLabel.Visible        := False;
  ProgForm.ProtectionLabel.Visible := False;
  ProgForm.ProgressLabel.Caption   := 'Updating Map';

  Cat := Blank;

  Image1.Visible := False;
  LoadBitStream;
  With SS do
   For ER:=SRow to ERow do
    Begin
     For EC:=SCol to ECol do
      Begin
        // Redraw the cell
        Redraw := False;
        DrawDike := False;

        //Get cell information
        RetA(ER,EC,CL);

        //If Show Connectivity box has been checked/unchecked or the cell is protected by dikes but showing box has been unchecked them
        if (ShowConnect) then
              begin
                case Connect_Array[(Site.Cols*ER)+EC] of
                  2 : Cat := TidalSwamp;       {Above Salt Bound = 2  [dark green]}
                  3 : Cat := InlandOpenWater;  {Connected = 3   [grey-blue]}
                  4 : Cat := IrregFloodMarsh;  {Unconnected = 4  [orange]}
                  5 : Cat := InlandShore;      {Irrelevant = 5     [brown]}
                  7 : if Cl.ProtDikes then Cat := OceanBeach   // yellow
                                      else Cat := Blank;       // white
                  8 : Cat := OpenOcean;        {Tidal Water = 8 [navy]}
                  else Cat := Blank;
                end;
                Redraw := True;
              end;

        if (not ShowConnect) and (Cl.ProtDikes) then
          Begin
            Redraw := True;
            DrawingTopLayer := False;
            if (Not ShowingDikes)
              then Cat := GetCellCat(@Cl)
              else
                begin
                  Cat := oceanbeach;  //yellow color for dikes
                  DrawDike := True;
                end;
          End;

        DrawRow := ER-SRow;
        DrawCol := EC-SCol;

        //Draw the cell
        if Redraw then
          DrawCell(@Cl,DrawRow,DrawCol,Cat,DrawDike,False,False,0);

      end;
     Application.Processmessages;
     Finished := ProgForm.Update2Gages(Trunc((ER)/(MapNR-1)*100));
     If Not Finished then break;
    End;
  Image1.Visible := True;
  SaveBitStream;
  ProgForm.Hide;
  RunPanel.Visible := False;
  Screen.Cursor := crDefault;
end;

procedure TGridForm.ShowDikesClick(Sender: TObject);
Begin
  If DontDraw then Exit;
  DontDraw := True;
  If Sender=ShowDikes2 then ShowDikes.Checked := ShowDikes2.Checked
                       else ShowDikes2.Checked := ShowDikes.Checked;
  DontDraw := False;
  ShowDikesOrConnect(False);
End;

Function TGridForm.ZF_From_Screen: Double;
Begin
  Result := 1.0;
  Case ZoomBox.ItemIndex of
    0: Result := 0.125;
    1: Result := 0.25;
    2: Result := 0.5;
    3: Result := 1.0;
    4: Result := 2.0;
    5: Result := 3.0;
  End; {Case}
End;

procedure TGridForm.ZoomBoxChange(Sender: TObject);
Var ZF: Double;
    TCB: TComboBox;
begin
  If Sender = nil then Sender := ZoomBox;

  TCB := TComboBox(Sender);
  Zoombox.ItemIndex := TCB.ItemIndex;
  Zoombox2.ItemIndex := TCB.ItemIndex;
  Zoombox3.ItemIndex := TCB.ItemIndex;

  ZF := ZF_From_Screen;
  IF ZF <> ZoomFactor then
   If MessageDlg('Redraw Entire Map?',mtconfirmation,[mbyes,mbno],0)=mryes then
    Begin
      ZoomFactor := ZF;

      DontDraw := True;
      If Showdikes.checked  then Showdikes.checked := false;
      If Showdikes2.checked  then Showdikes2.checked := false;
      DontDraw := False;

      ZoomFactor := ZF;
      BitStream.Free;
      BitStream := nil;
      DrawEntireMap(0,True,False);
      ProgForm.Hide;

      If PageControl1.Pages[0].TabVisible then ShowEditItems;
    End;
end;

procedure TGridForm.FormCreate(Sender: TObject);
begin
  LastRow := -9999;
  SlpFileN := '';
  ZoomFactor := 1.0;
  ZoomBox2.ItemIndex := 3;
  GraphBox.ItemIndex := 0;
  ZoomBox.ItemIndex := 3;

  Image1.Picture.Bitmap.PixelFormat := pf24bit;
  DefiningBoundary := False;
  DefiningVector := False;
  DrawingCells := False;
  FillingCells := False;
  DikesChanged := False;
  NWIChanged := False;
  Updating := False;

  DepthLabel.Caption := '';
  xlabel2.Caption := '';
  ylabel2.Caption := '';
  CategoryLabel.Caption := '';

  // Scroll Image
  ScrollBox1.DoubleBuffered := True;
end;

function ExecuteFile(const FileName, Params, DefaultDir: String;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..254] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;


procedure TGridForm.AddEstClick(Sender: TObject);
Begin With SS do
 Begin
  If DefEst.Checked then
    Begin
      Inc(NumFWFlows);
      If NumFWFlows > Length(FWFlows) then
        SetLength(FWFlows,NumFWFlows+5);
      FWFlows[NumFWFlows-1] := TFWFlow.Create;
      EditIndex := NumFWFlows-1;
    End;

  If DefInput.Checked then
    Begin
      Site.AddSubSite;
      EditIndex := Site.NSubSites-1;
//      ExecuteFile('NOTEPAD.EXE',Site.SubSites[EditIndex].FileN,'',SW_SHOW);
    End;

  If DefOutput.Checked then
    Begin
      Site.AddOutputSite;
      EditIndex := Site.NOutputSites-1;
    End;

  UpdateEditBox;
  ShowEditItems;
 End;
End;

procedure TGridForm.Button1Click(Sender: TObject);
begin
  If MessageDlg('Stop Process in Progress?',mtconfirmation,[mbyes,mbno],0)=Mrno then Exit;
  ProgForm.SimHalted := True;
  ProgressLabel.Caption := 'Halting Process in Progress';
end;

procedure TGridForm.Button3Click(Sender: TObject);
// Combine dikes - classic and with elevation using the uplift file
var
 ER, EC: integer;
 CL: Compressedcell;

begin
  If MessageDlg('Are you sure you want to combine dikes using the uplift file?',mtconfirmation,[mbyes,mbno],0)=Mrno then Exit;

  ProgForm.Show;
  ProgForm.ProgressLabel.Caption := 'Combining dikes';
  with SS do

    for ER :=0 to MapNR- 1 do
      for EC:=0 to MapNC-1 do
        begin

          // Get the cell
          RetA(ER,EC,CL);

          // Update the protection from dike using the uplift file
          if CL.Uplift > 0 then
            begin

              CL.ProtDikes := True;
              CL.ElevDikes := False;

              // Set the new cell
              SetA(ER,EC,CL);

              // Dike changed
              DikesChanged := True;
            end;
        end;

    ProgForm.Cleanup;

end;



procedure TGridForm.MapSaveSimulationButtonClick(Sender: TObject);
var
  pName: String;
begin
  if GridForm.DikesChanged then
    if PromptforFileName(pName,'ASC Files (*.ASC)|*.ASC','','Save your dike grid file','',True) then
    begin
      pName := ChangeFileExt(pName,'.ASC');
      SS.SaveRaster(pName,1 );
      SS.DikFileN := pName;
    end;

  if GridForm.NWIChanged then
    if PromptforFileName(pName,'ASC Files (*.ASC)|*.ASC','','Save your wetland grid file','',True) then
    begin
      pName := ChangeFileExt(pName,'.ASC');
      SS.SaveRaster(pName,2 );
      SS.NWIFileN := pName;
    end;

  GridForm.DikesChanged := False;
  GridForm.NWIChanged := False;

  MainForm.SaveSimClick(Sender);

end;

procedure TGridForm.TabChangeClick(Sender: TObject);
begin

  DrawingCells := False;
  FillingCells := False;
  PolyingCells := False;
  DefiningBoundary := False;
  DefiningVector := False;

  PanCheckBox.Checked := False;
  if (PageControl1.ActivePageIndex <> 1) then
     PanCheckBox.Checked := True;


    //SS.executerun.CALC_ELEV_STATS;
end;

(*
procedure TGridForm.PageControl1DrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
var
  AText: string;
  ARect: TRect;

begin
  with (Control as TPageControl).Canvas do
  begin
    ARect := Rect;
    OffsetRect(ARect, 0, 4);

    Brush.Color := clActiveCaption;
    FillRect(Rect);

    AText := TPageControl(Control).Pages[TabIndex].Caption;

    with Control.Canvas do
      DrawText(Control.Canvas.Handle, PChar(AText), -1,ARect, DT_CENTER or DT_SINGLELINE);

  end;

end;   *)

procedure TGridForm.PanCheckBoxClick(Sender: TObject);
begin
  Toolbox1.Enabled := not PanCheckBox.Checked;

end;

procedure TGridForm.PolyCellsClick(Sender: TObject);
begin
  If SS.OptimizeLevel > 1 then
    Begin
      MessageDlg('Cannot Edit Maps when maximum memory optimization is selected.  Change options in File-Setup.',
                  mterror,[mbok],0);
      Exit;
    End;

  SS.Connect_Array := nil;
  PenWidthBox.Enabled := False;
  DrawingCells := False;
  FillDikesBox.Enabled := True;
  FillNoDikesBox.Enabled := True;
  FillingCells := False;
  MapTitle2.Caption := 'Draw a Polygon to fill';
  MapTitle2.Visible := True;
  DoneDrawingButton.Visible := True;

  CategoryBox.Enabled := Not (FillDikes or FillNoDikes);
  PolyPoints := nil; {free memory for dynamic array}
  SetLength(PolyPoints,100);
  NumPolyPts := 0;
  DefiningBoundary := True;
  PolyingCells := True;
end;

procedure TGridForm.DeleteEstClick(Sender: TObject);
Var i: Integer;
Begin
 DefiningBoundary := False;

With SS do
 Begin
  If DefEst.Checked then
    Begin
      If NumFWFlows = 0 then Exit;

      If MessageDlg('Delete Estuary "'+FWFlows[EditIndex].Name+'" ?',mtconfirmation,[mbyes,mbno],0)
        = mrno then exit;

      FWFlows[EditIndex].Destroy;
      For i:= EditIndex to NumFWFlows-2 do
        FWFlows[i] := FWFlows[i+1];

      Dec(NumFWFlows);
    End;

  IF DefInput.Checked then
    Begin
      If Site.NSubSites = 0 then Exit;
      If MessageDlg('Delete Subsite "'+Site.SubSites[EditIndex].Description+'" ?',mtconfirmation,[mbyes,mbno],0)
        = mrno then exit;
      Site.DelSubSite(EditIndex);
    End;

  IF DefOutput.Checked then
    Begin
      If Site.NOutputSites = 0 then Exit;
      If MessageDlg('Delete Output site "'+Site.OutputSites[EditIndex].Description+'" ?',mtconfirmation,[mbyes,mbno],0)
        = mrno then exit;

      Site.DelOutputSite(EditIndex);
    End;

  EditIndex := 0;
  UpdateEditBox;
  ShowEditItems;
 End;
End;



procedure TGridForm.DoneDrawingButtonClick(Sender: TObject);
begin
  DrawingCells := False;
  FillDikesBox.Enabled := False;
  FillNoDikesBox.Enabled := False;
  FillingCells := False;
  MapTitle2.Caption := '';
  MapTitle2.Visible := False;
  DoneDrawingButton.Visible := False;
  SaveSim3.Enabled := True;
  CategoryBox.Enabled := False;
  DefiningBoundary := False;
  PolyingCells := False;
  PenWidthBox.Enabled := False;
end;

Procedure TGridForm.DrawArrow(P1,P2: TPoint);
Var HeadLength :  INTEGER;
    xbase      :  INTEGER;
    xLineDelta      :  INTEGER;
    xLineUnitDelta  :  Double;
    xNormalDelta    :  INTEGER;
    xNormalUnitDelta:  Double;
    ybase           :  INTEGER;
    yLineDelta      :  INTEGER;
    yLineUnitDelta  :  Double;
    yNormalDelta    :  INTEGER;
    yNormalUnitDelta:  Double;
    i: Integer;
Begin
 For i := 0 to 1 do
  Begin
    If i=0 then Image1.Canvas.Pen.Width := 4
           else Image1.Canvas.Pen.Width := 2;

    Image1.Canvas.Pen.Style := PSSolid;
    Image1.Canvas.Pen.Mode := pmCopy;

    If i=0 then Image1.Canvas.Pen.Color := ClBlack
           else Image1.Canvas.Pen.Color := ClWhite;

    Image1.Canvas.MoveTo(Trunc(p1.X*Zoomfactor),Trunc(P1.Y*Zoomfactor));
    Image1.Canvas.LineTo(Trunc(p2.X*Zoomfactor),Trunc(P2.Y*Zoomfactor));

    xLineDelta := p2.X - p1.X;
    yLineDelta := P2.Y - P1.Y;

    xLineUnitDelta := xLineDelta / SQRT( SQR(xLineDelta) + SQR(yLineDelta) );
    yLineUnitDelta := yLineDelta / SQRt( SQR(xLineDelta) + SQR(yLineDelta) );

    // (xBase,yBase) is where arrow line is perpendicular to base of triangle.
    HeadLength := 12; // pixels

    xBase := p2.X - ROUND(HeadLength * xLineUnitDelta);
    yBase := P2.Y - ROUND(HeadLength * yLineUnitDelta);

    xNormalDelta :=  yLineDelta;
    yNormalDelta := -xLineDelta;
    xNormalUnitDelta := xNormalDelta / SQRT( SQR(xNormalDelta) + SQR(yNormalDelta) );
    yNormalUnitDelta := yNormalDelta / SQRt( SQR(xNormalDelta) + SQR(yNormalDelta) );

    // Draw the arrow tip
    Image1.Canvas.Polygon([Point(ZF(p2.X),ZF(P2.Y)),
                           Point(ZF(xBase + ROUND(HeadLength*xNormalUnitDelta)),
                                 ZF(yBase + ROUND(HeadLength*yNormalUnitDelta))),
                           Point(ZF(xBase - ROUND(HeadLength*xNormalUnitDelta)),
                                 ZF(yBase - ROUND(HeadLength*yNormalUnitDelta))) ]);
  End;
  Image1.Canvas.Pen.Width := 1;

End;

Procedure TGridForm.DrawVector;
Var i,j: Integer;
Begin
 With SS do
  Begin
    If ShowAll.Checked then
     For j := 0 to NumFWFlows-1 do
      With FWFlows[j] do
       For i := 0 to NumSegments - 1 do
         DrawArrow(OriginArr[i],MouthArr[i]);

    With FWFlows[EditIndex] do
     {Draw Origin, Mouth}
     If NumSegments =  0  then PointWarning.Visible := True
      Else
       Begin
         PointWarning.Visible := False;
         For i := 0 to NumSegments - 1 do
           DrawArrow(OriginArr[i],MouthArr[i]);
       End;
  End;
End;

Procedure TGridForm.DrawBound(Var TPoly: TPolygon);
Var i: Integer;
Begin
 With TPoly do
  Begin
    IF NumPts = 0 then Exit;
    Image1.Canvas.MoveTo(ZF(TPoints[0].X),ZF(TPoints[0].Y));
    For i := 2 to NumPts do
      Image1.Canvas.LineTo(Trunc((TPoints[i-1].X)*Zoomfactor),Trunc((TPoints[i-1].Y)*Zoomfactor));
    Image1.Canvas.LineTo(Trunc((TPoints[0].X)*Zoomfactor),Trunc((TPoints[0].Y)*Zoomfactor));
  End;
End;

Procedure TGridForm.DrawOutputsites;

  Procedure DrawRec(Var TS: TOutputsite2);
  Begin
   With TS.Rec do
    Begin
      IF (X1<-50) or (X2<-50) then Exit;
      Image1.Canvas.MoveTo(ZF(X1),ZF(Y1));
      Image1.Canvas.LineTo(ZF(X1),ZF(Y2));
      Image1.Canvas.LineTo(ZF(X2),ZF(Y2));
      Image1.Canvas.LineTo(ZF(X2),ZF(Y1));
      Image1.Canvas.LineTo(ZF(X1),ZF(Y1));
    End;
  End;

  Procedure DrawOS(Var TS: TOutputsite2);
  Begin
    If TS.UsePolygon then DrawBound(TS.Poly)
                     else DrawRec(TS);

  End;

Var j: Integer;
Begin
  Image1.Canvas.Pen.Width := 2;
  Image1.Canvas.Pen.Style := PSSolid;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.Pen.Color := clWhite;

  If ShowAll.Checked then
   For j := 0 to SS.Site.NOutputSites-1 do
    DrawOS(SS.Site.OutputSites[j]);

  If ShowAll.Checked then Image1.Canvas.Pen.Color := clYellow;
  DrawOS(SS.Site.OutputSites[EditIndex]);
End;

Procedure TGridForm.DrawBoundary(IsEst: Boolean);

Var j: Integer;
Begin
  Image1.Canvas.Pen.Width := 2;
  Image1.Canvas.Pen.Style := PSSolid;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.Pen.Color := clWhite;

  With SS do
  If ShowAll.Checked then
    If IsEst then
      Begin
         For j := 0 to NumFWFlows-1 do
           DrawBound(FWFlows[j].Poly);
      End
    else
      Begin
         For j := 0 to Site.NSubSites-1 do
           DrawBound(Site.Subsites[j].Poly);
      End;

  If ShowAll.Checked then Image1.Canvas.Pen.Color := clYellow;

  If IsEst then DrawBound(SS.FWFlows[EditIndex].Poly)
           else DrawBound(SS.Site.Subsites[EditIndex].Poly);
End;

Procedure TGridForm.HighlightCells;
Var R, C: Integer;
    SC: tcursor;
Begin
  With SS.FWFlows[EditIndex].Poly do
    If (NumPts = 0) or (TPoints = nil) then exit;

  Image1.Canvas.Pen.Style := PSSolid;
  Image1.Canvas.Pen.Mode := pmCopy;

  SC := Screen.Cursor;
  Screen.Cursor := crHourglass;
  With SS do
  With FWFlows[EditIndex].Poly do
   For R:=0 to MapNR-1 do
    For C:=0 to MapNC-1 do
      Begin
        If (ZoomFactor = 0.5)  and (R Mod 2 > 0) then Continue;
        If (ZoomFactor = 0.5)  and (C Mod 2 > 0) then Continue;
        If (ZoomFactor = 0.25)  and (R Mod 4 > 0) then Continue;
        If (ZoomFactor = 0.25)  and (C Mod 4 > 0) then Continue;
        If (ZoomFactor = 0.125)  and (R Mod 8 > 0) then Continue;
        If (ZoomFactor = 0.125)  and (C Mod 8 > 0) then Continue;

        If InPoly(R,C) then
          Image1.Canvas.Pixels[Trunc(C*Zoomfactor),Trunc(R*Zoomfactor)] := clolive;  //optimize?
      End;
  Screen.Cursor := SC;
End;



procedure TGridForm.ShowEditItems;
Begin
  FWExtentOnly.Visible := False;
  LoadBitStream;

  With SS do
   If DefEst.Checked then
    Begin
      If NumFWFlows<1 then exit;
      With FWFlows[EditIndex] do
        Begin
          Updating := True;
          NameEdit.Text := Name;
          Updating := False;

          FWExtentOnly.Visible := True;
          FWExtentOnly.Checked := ExtentOnly;

          {Draw Boundary}
          BoundaryWarning.Visible := False;
          If Poly.TPoints = nil then BoundaryWarning.Visible := True
                                Else if Poly.NumPts < 2 then BoundaryWarning.Visible := True;

          If ShowLines.Checked or ShowAll.Checked
             then DrawBoundary(True)
             else HighlightCells;

          DrawVector;
        End;
    End;

  If DefInput.Checked then With SS do
    Begin
      If Site.NSubSites <1 then exit;
      With Site.Subsites[EditIndex] do
        Begin
          Updating := True;
          NameEdit.Text := Description;
          Updating := False;
          BoundaryWarning.Visible := False;
          If Poly.TPoints = nil then BoundaryWarning.Visible := True
                                Else if Poly.NumPts < 2 then BoundaryWarning.Visible := True;
          DrawBoundary(False);
        End;
    End;

  If DefOutput.Checked then with SS do
    Begin
      If Site.NOutputSites <1 then exit;
      With Site.OutputSites[EditIndex] do
        Begin
          Updating := True;
          NameEdit.Text := Description;
          Updating := False;
          With Rec do
            BoundaryWarning.Visible := (X1 < -50) or (Y1<-50);
          DrawOutputSites;
        End;
    End;

End;

procedure TGridForm.DefineBoundClick(Sender: TObject);
begin
  PolyingCells := False;

  If DefEst.Checked then with SS do
   Begin
     If NumFWFlows = 0 then AddEstClick(nil);
     With FWFlows[EditIndex].Poly do
      Begin
        If TPoints <> nil then
          Begin
            if MessageDlg('Redefine Boundary?',mtconfirmation,[mbyes,mbno],0)=mrno then exit;
            TPoints := nil; {free memory for dynamic array}
          End;

        SetLength(TPoints,100);
        NumPts := 0;
      End;
   End;

  If DefInput.Checked then with SS do
   Begin
    If Site.NSubSites = 0 then AddEstClick(nil);
     With Site.SubSites[EditIndex].Poly do
      Begin

        If TPoints <> nil then
          Begin
            if MessageDlg('Redefine Sub-site?',mtconfirmation,[mbyes,mbno],0)=mrno then exit;
            TPoints := nil; {free memory for dynamic array}
{            X1 := -99; Y1 := -99; }
          End;
        SetLength(TPoints,100);
        NumPts := 0;

      End;
   End;

  If DefOutput.Checked then with SS do
   Begin
    If Site.NOutputSites = 0 then AddEstClick(nil);
     With Site.OutputSites[EditIndex] do With rec do
      Begin
        If (X1>=0) or (Y1>=0) then
          Begin
            if MessageDlg('Redefine Output-site?',mtconfirmation,[mbyes,mbno],0)=mrno then exit;
            X1 := -99; Y1 := -99;
            UsePolygon := False;
          End;
      End;
   End;

  ShowEditItems;
  DefiningBoundary := True;
end;

procedure TGridForm.DefineVectorClick(Sender: TObject);
begin
 PolyingCells := False;

  With SS do With FWFlows[EditIndex] do
    Begin
      If OriginArr <> nil then
        Begin
          if MessageDlg('Redefine estuary path?',mtconfirmation,[mbyes,mbno],0)=mrno then exit;
          OriginArr := nil; {free memory for dynamic array}
          MouthArr  := nil;
        End;

      SetLength(OriginArr,20);
      SetLength(MouthArr,20);

      NumSegments := 0;

      NextOriginX := -99;
      NextOriginY := -99;

      ShowEditItems;
      DefiningVector := True;
    End;
end;




procedure TGridForm.EditBoxChange(Sender: TObject);
begin
  EditIndex := EditBox.ItemIndex;
  ShowEditItems;
end;

procedure TGridForm.ElevationButtonClick(Sender: TObject);
begin
  ElevAnalysisForm.MapLoaded := True;
  ElevAnalysisForm.ElevationAnalysis(SS);
end;

procedure TGridForm.NameEditChange(Sender: TObject);
begin
 With SS do
   Begin
      If Updating then exit;
      If DefEst.Checked then
        Begin
          If NumFWFlows = 0 then AddEstClick(nil);
          With FWFlows[EditIndex] do
            Name := NameEdit.Text;
        End;

      If DefOutput.Checked then
        Begin
          If Site.NOutputSites = 0 then AddEstClick(nil);
          With Site.OutputSites[EditIndex] do
            Description := NameEdit.Text;
        End;

      If DefInput.Checked then
        Begin
          If Site.NSubSites = 0 then AddEstClick(nil);
          With Site.SubSites[EditIndex] do
            Description := NameEdit.Text;
        End;
   End;

end;

procedure TGridForm.NameEditExit(Sender: TObject);
begin
  UpdateEditBox;
end;

procedure TGridForm.NextStepButtonClick(Sender: TObject);
begin
  ShowRunPanel;
end;

procedure TGridForm.ROSButtonClick(Sender: TObject);
Var ER, EC, GBII: Integer;
    ROS: Byte;
    SvCrs: TCursor;
    Cl: CompressedCell;

{    MinElv: Single;  }
begin
  Inc(ROSShowing);
  If ROSShowing > ThisSite.MaxROS then ROSShowing :=0;
  If ROSShowing = 0 then ROSLabel.Caption := 'Raster Output Shown = none'
                    else ROSLabel.Caption := 'Raster Output Shown = '+ IntToStr(ROSShowing);

  if SS.ROSArray=nil then Exit;
  Image1.Visible := False;

  SvCrs := Screen.Cursor;
  Screen.Cursor := crHourglass;
  GridForm.Image1.Canvas.Pen.Mode := pmcopy;
  GBII := GraphBox.ItemIndex;
  With SS do
   For ER :=0 to MapNR- 1 do
    For EC:=0 to MapNC-1 do
      Begin
        RetA(ER,EC,CL);
        ROS := ROSArray[(Site.Cols*ER)+EC];
        If (ROS > 0)
          then
            Begin
              If ROS = ROSShowing
                then DrawCell(@CL,ER,EC,Blank,False,True,False,0)  {Draw ROS as white}
                else DrawCell(@CL,ER,EC,GetCellCat(@Cl),False,False,False,0); {Draw Category}
            End;
      End;
  Screen.Cursor := SvCrs;
  Image1.Visible := True;
  SaveBitStream;
  ProgForm.Hide;
  RunPanel.Visible := False;

end;


procedure TGridForm.ShowCellsClick(Sender: TObject);
begin
  ShowEditItems;
end;

procedure TGridForm.ShowLinesClick(Sender: TObject);
begin
  ShowEditItems;
end;

procedure TGridForm.AddDikeButtClick(Sender: TObject);
begin
  If SS.OptimizeLevel > 1 then
    Begin
      MessageDlg('Cannot Edit Maps when maximum memory optimization is selected.  Change options in File-Setup.',
                  mterror,[mbok],0);
      Exit;
    End;

  SS.Connect_Array := nil;
  
  PenWidthBox.Enabled := True;
  PenWidthBox.ItemIndex := 1;
  DrawingCells := True;
  FillDikesBox.Enabled := True;
  FillNoDikesBox.Enabled := True;
  FillingCells := False;
  MapTitle2.Caption := 'Drawing Cells, Click to Draw';
  MapTitle2.Visible := True;
  DoneDrawingButton.Visible := True;

  FillDikes := FillDikesBox.Checked;
  FillNoDikes := FillNoDikesBox.Checked;

  CategoryBox.Enabled := Not (FillDikes or FillNoDikes);
end;

procedure TGridForm.FillDikeButtClick(Sender: TObject);
begin
  If SS.OptimizeLevel > 1 then
    Begin
      MessageDlg('Cannot Edit Maps when maximum memory optimization is selected.  Change options in File-Setup.',
                  mterror,[mbok],0);
      Exit;
    End;

  SS.Connect_Array := nil;    
  FillingCells := True;
  DrawingCells := False;
  MapTitle2.Caption := 'Filling Cells, Click on Map';
  MapTitle2.Visible := True;
  DoneDrawingButton.Visible := True;

  FillDikesBox.Enabled := True;
  FillNoDikesBox.Enabled := True;

  FillDikes := FillDikesBox.Checked;
  FillNoDikes := FillNoDikesBox.Checked;

  CategoryBox.Enabled := Not (FillDikes or FillNoDikes);
end;

procedure TGridForm.DefEstClick(Sender: TObject);
begin

  If DefEst.Checked then EstNameCapt.Caption := 'Est. Name'
                    else EstNameCapt.Caption := 'Sub-site:';
  DefineVector.Visible := DefEst.Checked;
  PointWarning.Visible := DefEst.Checked;
  FWExtentOnly.Visible := DefEst.Checked;
  ShowCells.Visible    := DefEst.Checked;
  SubsiteParmButt.Visible := DefInput.Checked;
  FWFlowButton.Visible := DefEst.Checked;

  EditIndex := 0;
  UpdateEditBox;
  ShowEditItems;

end;

procedure TGridForm.SubsiteParmButtClick(Sender: TObject);
begin
    SiteEditForm.EditSubSites(SS);  {}
end;

end.
