unit Infrastructure;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Buttons, Vcl.StdCtrls, Vcl.ExtCtrls, SLR6;

type
  TInfStructFileSetup = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    FN1: TLabel;
    Label11: TLabel;
    FileEdit1: TEdit;
    Button1: TButton;
    DikeCasePanel: TPanel;
    ClassicDikeCaseRadioButton: TRadioButton;
    DikeLocationCaseRadioButton: TRadioButton;
    Panel2: TPanel;
    Label2: TLabel;
    Label12: TLabel;
    FN2: TLabel;
    FileEdit2: TEdit;
    Button2: TButton;
    CheckValidityButton: TButton;
    OKButton10: TButton;
    CancelButton: TButton;
    HelpButton: TBitBtn;
    SaveButton: TButton;
    OpenDialog2: TOpenDialog;
    Panel3: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    Button3: TButton;
    Panel4: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit2: TEdit;
    Button4: TButton;
    procedure CheckValidityButtonClick(Sender: TObject);
    procedure FileEdit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DikeCaseRadioButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
  private
    PSS: TSLAMM_Simulation;
    Updating: Boolean;
    BClassicDike : Boolean;
    BInfStFileN : String;
    { Private declarations }
  public
    BDikFileN  : String;
    Procedure EditFileInfo(Var SS: TSLAMM_Simulation);
    Procedure UpdateScreen;
    { Public declarations }
  end;

var
  InfStructFileSetup: TInfStructFileSetup;

implementation

{$R *.dfm}

uses global, main, System.UITypes, FileSetup;

procedure TInfStructFileSetup.EditFileInfo(var SS: TSLAMM_Simulation);
begin
    PSS := SS;

    BDikFileN  := SS.DikFileN;
    BClassicDike := SS.ClassicDike;

    FN1.Visible := False;
    FN2.Visible := False;

    FileEdit1.Color := ClWindow;
    FileEdit2.Color := ClWindow;

    CheckValidityButtonClick(nil);

    UpdateScreen;

    If ShowModal = MROK then
      Begin
        SS.DikFileN := BDikFileN ;
        SS.ClassicDike := BClassicDike ;

        SS.Changed := True;
      End;

    MainForm.UpdateScreen;

end;

procedure TInfStructFileSetup.FileEdit1Change(Sender: TObject);
begin
   If Updating then Exit;
   If Sender=FileEdit1 then BDikFileN := FileEdit1.Text;
   If Sender=FileEdit2 then BInfStFileN := FileEdit2.Text;

   CancelButton.Enabled := True;
end;

procedure TInfStructFileSetup.SaveButtonClick(Sender: TObject);
begin
MainForm.SaveSimClick(Sender);
CancelButton.Enabled :=  False;
end;

procedure TInfStructFileSetup.Button1Click(Sender: TObject);
Var TEB: TEdit;
    Str: String;
begin
  TEB := nil;
  Case TButton(Sender).Name[7] of
    '1': TEB := FileEdit1;
    '2': TEB := FileEdit2;
   End;

  Str := TEB.Text;
  OpenDialog2.InitialDir := ExtractFilePath(Str);
  If OpenDialog2.Execute then TEB.Text:=OpenDialog2.Filename;
end;

procedure TInfStructFileSetup.CancelButtonClick(Sender: TObject);
begin
  If MessageDlg('Cancel all Changes?',mtconfirmation,[mbyes,mbno],0) = MRyes then
    ModalResult := MRCancel;
end;

procedure TInfStructFileSetup.CheckValidityButtonClick(Sender: TObject);
begin
FileSetupForm.CheckValidityButtonClick(Sender);
end;

procedure TInfStructFileSetup.DikeCaseRadioButtonClick(Sender: TObject);
begin
  If Updating then Exit;

  BClassicDike := ClassicDikeCaseRadioButton.Checked;

  UpdateScreen;
end;

procedure TInfStructFileSetup.UpdateScreen;
begin
    Updating := True;
    FileEdit1.Text := BDikFileN;
    FileEdit2.Text := BInfStFileN;

    Updating := False;

    Update;
end;



end.
