//SLAMM SOURCE CODE copyright (c) 2009 - 2012 Warren Pinnacle Consulting, Inc.
//Code Use and Redistribution is Subject to Licensing, SEE SLAMM_License.txt
//

unit Progress;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges;

type
  TProgForm = class(TForm)
    ProgressLabel: TLabel;
    YearLabel: TLabel;
    SLRLabel: TLabel;
    ProtectionLabel: TLabel;
    Button1: TButton;
    Gauge1: TGauge;
    UncertStatusLabel: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    G2,PL2,F2, YL2, SLR2, Prot2: Pointer;
    SimHalted: Boolean;
    Function Update2Gages(Level: Integer):Boolean;
    Procedure Cleanup;
    { Public declarations }
  end;

var
  ProgForm: TProgForm;

implementation

uses System.UITypes;

{$R *.DFM}

procedure TProgForm.Button1Click(Sender: TObject);
begin
  If MessageDlg('Stop Process in Progress?',mtconfirmation,[mbyes,mbno],0)=Mrno then Exit;
  SimHalted := True;
  ProgressLabel.Caption := 'Halting Process in Progress';
end;

procedure TProgForm.Cleanup;
begin
   PL2 := nil;
   YL2 := nil;
   SLR2 := nil;
   Prot2 := nil;
   Hide;
end;

procedure TProgForm.FormCreate(Sender: TObject);
begin
  G2 := nil;
  PL2 := nil;
  F2 := nil;
  YL2 := nil;
  SLR2 := nil;
  Prot2 := nil;
  SimHalted := False;
end;

Function TProgForm.Update2Gages(Level:Integer):Boolean;
Begin
  Result := Not SimHalted;
  SimHalted := False;

  Try
  If Gauge1.Progress <> Level then
    Begin
      Gauge1.Progress := Level;
      Paint;
      Update;
    End;
  Application.Processmessages;
  Except
    Update;
  End
End;



procedure TProgForm.FormPaint(Sender: TObject);
begin
  If PL2 <> nil then
    TLabel(PL2).Caption := ProgressLabel.Caption;
  If YL2 <> nil then
    TLabel(YL2).Caption := YearLabel.Caption;
  If SLR2 <> nil then
    TLabel(SLR2).Caption := SLRLabel.Caption;
  If Prot2 <> nil then
    TLabel(Prot2).Caption := ProtectionLabel.Caption;
  If PL2 <> nil then
    TLabel(PL2).Visible := ProgressLabel.Visible;
  If YL2 <> nil then
    TLabel(YL2).Visible := YearLabel.Visible;
  If SLR2 <> nil then
    TLabel(SLR2).Visible := SLRLabel.Visible;
  If Prot2 <> nil then
    TLabel(Prot2).Visible := ProtectionLabel.Visible;

  If G2 <> nil then
    TGauge(G2).Progress := Gauge1.Progress;
  If F2 <> nil then
    TForm(F2).Update;
end;

end.
